unit Tri;
{
  Copyright (C) 2013-2015 Marc SERRAU

  This source is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your option)
  any later version.

  This code is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
  details.

  A copy of the GNU General Public License is available on the World Wide Web
  at <http://www.gnu.org/copyleft/gpl.html>. You can also obtain it by writing
  to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
  MA 02111-1307, USA.
}
{$MODE Delphi}

// unité locale au projet gcvs : des aménagements l'ont légèrement modifiée : maxobj, T_key
interface
const
   MaxObj = 100000;
type
   key = record
      rang : longint;
      value : string;
   end;
   T_key = ^key;
   T_Table = array[0..MaxObj] of T_key;
   P_Table = ^T_Table;

procedure SortTable(les_chiffres : P_Table; nombre : longint);
function RechercheIndex(table : P_table; taille : longint; rech : string):longint;

implementation


const
   MaxRecur = 100000;
   Tabulation = #9;

function RechercheIndex(table : P_table; taille : longint; rech : string):longint;
var
   lim,i,anc,inf,sup  : longint;
   fin,trouve : boolean;
begin
   lim:=trunc(ln(taille)/ln(2));
   trouve:=false;
   fin:=false;
   anc:=trunc(taille/2);
   inf:=1;
   i:=0;
   sup:=taille+1;
   repeat
       if i>(lim+1) then fin:=true;
       if Upcase(table^[anc].value)=Upcase(rech) then
          trouve:=true
       else
       begin
          inc(i);
          if Upcase(table^[anc].value)>Upcase(rech) then
          begin
             sup:=anc;
             anc:=trunc((inf+anc)/2);
          end
          else
          begin
             inf:=anc;
             anc:=trunc((sup+anc)/2);
          end
       end
   until trouve or fin;
   if trouve then RechercheIndex:=table^[anc].rang else RechercheIndex:=0;
end;

procedure SortTable(les_chiffres : P_Table; nombre : longint);
Var
   s, sj, sl, sr, j,S1,resa_rang : LongInt;        // les compteurs intermediaires  du tri
   Code: string;                       // Clef de recherche
   Resa_Chiffre: string;               // Utiliser pour les permutation doit etre du mÍme type que la donnÈee triÈe
   St: Array[0..MaxRecur, 0..1] Of LongInt;  // Table qui remplace la recursivitÈ et amÈliore CONSIDERABLEMENT les performances
                                        // le dimensionnement  100 correspond au nombre maximal d'appel en recursivitÈ
                                        // normalement 10 devraient suffir mais avec 100 on doit pouvoir trier quelque milliards d'infos...
Begin
     S := 1;                            // IMPORTANT je ne trie pas l'ÈlÈment ZERO
     st[S, 0] := 1;                     // Il suffit normalement de metrre S  zero pour le trier
     st[S, 1] := nombre;                 // Nombre d'elements  trier
     Repeat
       sl := st[S, 0];                  // Sauvegarde des offsets pour la recursivitÈ
       sr := st[S, 1];
       S := pred(S);
       Repeat
         j := sl;                       // le quick sort trie le fichier par morceau de plus en plus grands
         sj := sr;
         S1 := (sl + sr) Div 2;            //  on divise le nombre d'elements choisi par deux
         Code := Les_Chiffres^[S1].value;  // On mÈmorise le criter de tri de l'elemnt actif (plus de xclarte dans les tests  suivre
         Repeat
           While (Les_Chiffres^[J].value < Code) Do   // Partant du debut de la portion selectionnÈe on, recherche le p
             j := j + 1;                               // premier element plus grand dans cet interval
           While (Code < Les_Chiffres^[Sj].value) Do  // maintenant on recherchje le plus petit partant de la fin
             SJ := Sj - 1;
           If j <= sj Then                            // quand on a trouve on permute avec resa_Chiffre
            Begin                                     // l'autre concept du quick sort est que plus la  permutation est
              Resa_Chiffre := Les_Chiffres^[Sj].value;  // lointaine plus elle est efficace: il vaut mieux permuter le premier
              Resa_rang := Les_Chiffres^[Sj].rang;
              Les_Chiffres^[Sj].value := Les_Chiffres^[j].value;        // avec le dernier que le premier avec le second
              Les_Chiffres^[Sj].rang := Les_Chiffres^[j].rang;
              Les_Chiffres^[j].value := Resa_Chiffre;    // il a plus de chance d'Ítre  sa place
              Les_Chiffres^[j].rang := Resa_rang;
              j := Succ(J);                           // Je laisse les mathÈmaticiens le dÈmontrer....
              sj := Pred(sj);                         // on retrecie la portion de recherche jusqu'a son arrivÈe  0 elements
            End;
         Until j > sj;
         If j < sr Then                               // Et c'est la qu'on recursive en se servant de la table
           Begin
             S := Succ(S);
             St[S, 0] := j;
             St[S, 1] := sr;
           End;
         sr := sj;
       until sl >= sr;
     Until S < 1;
End;                                                  // et la c'est FINI

end.
