unit Unit1;
{
  Copyright (C) 2013-2019 Marc SERRAU

  This source is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your option)
  any later version.

  This code is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
  details.

  A copy of the GNU General Public License is available on the World Wide Web
  at <http://www.gnu.org/copyleft/gpl.html>. You can also obtain it by writing
  to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
  MA 02111-1307, USA.
}

{$MODE Delphi}

interface
{$IFDEF MSWINDOWS}
uses
  Windows, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Unit2, ExtCtrls, CheckLst, Menus, Buttons, WinInet,
  StrUtils, DateUtils, Spin, FileUtil, Tri, Decoupe, MaskEdit, EditBtn, ValEdit,
  Grids, FTPSend, httpsend, types, fpjson, jsonparser;
{$ELSE}
uses
  Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Unit2, ExtCtrls, CheckLst, Menus, Buttons,
  StrUtils, DateUtils, Spin, FileUtil, Tri, Decoupe,
  MaskEdit, EditBtn, FTPSend, httpsend, types;
{$ENDIF}
const
   max_GCVS = 100000;
type

  { TForm1 }

  TForm1 = class(TForm)
    ButtonAgree: TButton;
    ButtonEffaceVariableCourante: TButton;
    ButtonExportRR: TButton;
    ButtonNovaeTxt: TButton;
    Button7: TButton;
    ButtonMesuresAFOEVListe: TButton;
    ButtonMesureAFOEV: TButton;
    CheckBoxClassifiedSN: TCheckBox;
    CheckBoxFiltreLExistant: TCheckBox;
    CheckMag2ndMin: TCheckBox;
    CheckBoxEst: TCheckBox;
    CheckBoxRechercheNovaDate: TCheckBox;
    CheckBoxDateSN: TCheckBox;
    ComboBoxIAU: TComboBox;
    DateTimePicker3: TDateEdit;
    DateTimePicker2: TDateEdit;
    DateTimePicker1: TDateEdit;
    EditMagLimit: TEdit;
    Label18: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    Label38: TLabel;
    Label39: TLabel;
    Label40: TLabel;
    LabelMagLimite: TLabel;
    LabelPosition: TLabel;
    LabeledEditMin2: TLabeledEdit;
    ListBoxAFOEVObs: TListBox;
    MaskEditLat: TMaskEdit;
    MaskEditLong: TMaskEdit;
    Memo3: TMemo;
    Memo4: TMemo;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    PageControl1: TPageControl;
    StringGridpourCSV: TStringGrid;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Memo1: TMemo;
    CheckListBox1: TCheckListBox;
    CheckListBox2: TCheckListBox;
    ButtonVLP: TButton;
    ButtonVCP: TButton;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    CheckTypeVar: TCheckBox;
    CheckConstel: TCheckBox;
    CheckMagMax: TCheckBox;
    CheckMagMin: TCheckBox;
    CheckDecMin: TCheckBox;
    LabeledEdit3: TLabeledEdit;
    CheckDecMax: TCheckBox;
    LabeledEdit4: TLabeledEdit;
    BitBtnExportVariable: TBitBtn;
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Sauverconfig1: TMenuItem;
    ButtonMira: TButton;
    ButtonRRLyrae: TButton;
    ButtonAucunType: TButton;
    ButtonTousType: TButton;
    ButtonAucuneConstel: TButton;
    ButtonTouteConstel: TButton;
    Quitter1: TMenuItem;
    LabeledEdit5: TLabeledEdit;
    CheckADMax: TCheckBox;
    LabeledEdit6: TLabeledEdit;
    CheckADMin: TCheckBox;
    TabSheet3: TTabSheet;
    LabeledEdit8: TLabeledEdit;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    LabeledEdit9: TLabeledEdit;
    LabeledEdit10: TLabeledEdit;
    LabeledEdit11: TLabeledEdit;
    LabeledEdit12: TLabeledEdit;
    LabeledEdit13: TLabeledEdit;
    LabeledEdit14: TLabeledEdit;
    LabeledEdit15: TLabeledEdit;
    LabeledEdit16: TLabeledEdit;
    LabeledEdit7: TLabeledEdit;
    Button1: TButton;
    Label1: TLabel;
    ButtonFiltrer: TButton;
    Label2: TLabel;
    SaveDialog1: TSaveDialog;
    Label3: TLabel;
    Configurer1: TMenuItem;
    ListView1: TListView;
    PopupMenu1: TPopupMenu;
    Effacer1: TMenuItem;
    CheckBoxRefiltrer: TCheckBox;
    ButtonImportAFOEV: TButton;
    LabeledEdit17: TLabeledEdit;
    LabeledEdit18: TLabeledEdit;
    Image1: TImage;
    Panel1: TPanel;
    LabeledEdit19: TLabeledEdit;
    CheckPerMax: TCheckBox;
    LabeledEdit20: TLabeledEdit;
    CheckPerMin: TCheckBox;
    PopupMenu2: TPopupMenu;
    TabSheet8: TTabSheet;
    Voirdtails1: TMenuItem;
    TabSheet4: TTabSheet;
    ButtonRecupSNHttp: TButton;
    Label4: TLabel;
    ButtonExportSN_Prism: TButton;
    ListView2: TListView;
    Label5: TLabel;
    Label6: TLabel;
    LabeledEditMagSNLimite: TLabeledEdit;
    CheckBoxMagSN: TCheckBox;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    CheckBoxAlphaSN: TCheckBox;
    CheckBoxDeltaSN: TCheckBox;
    ButtonRechAAVSO: TButton;
    PopupMenu3: TPopupMenu;
    Voirchamp1: TMenuItem;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Voirchamp2: TMenuItem;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    ListView3: TListView;
    Label15: TLabel;
    Label16: TLabel;
    Button3: TButton;
    Button4: TButton;
    SpinEdit1: TSpinEdit;
    Label17: TLabel;
    SpinEdit2: TSpinEdit;
    LabeledEditSeparation: TLabeledEdit;
    Label19: TLabel;
    Button5: TButton;
    OpenDialog1: TOpenDialog;
    PopupMenu4: TPopupMenu;
    MenuItem1: TMenuItem;
    ButtonRecupGEOS: TButton;
    Label20: TLabel;
    LabeledEditMagNovaeLimite: TLabeledEdit;
    CheckBoxMagLimiteNovae: TCheckBox;
    ButtonNovaePrism: TButton;
    Label21: TLabel;
    Label22: TLabel;
    ListView4: TListView;
    CheckListBoxNovae: TCheckListBox;
    ButtonRecupNovae: TButton;
    ButtonRAZ: TButton;
    Label23: TLabel;
    TabSheet7: TTabSheet;
    Publiermesures1: TMenuItem;
    GroupBox1: TGroupBox;
    LabeledEditVariablePublic: TLabeledEdit;
    GroupBox2: TGroupBox;
    LabeledEditObservateur: TLabeledEdit;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    LabeledEdit23: TLabeledEdit;
    GroupBox3: TGroupBox;
    MaskEditHeure: TMaskEdit;
    Label25: TLabel;
    Label24: TLabel;
    SpinEdit3: TSpinEdit;
    SpinEdit4: TSpinEdit;
    SpinEdit5: TSpinEdit;
    GroupBox4: TGroupBox;
    MaskEdit2: TMaskEdit;
    RadioGroup3: TRadioGroup;
    MaskEditMagnitude: TMaskEdit;
    Label26: TLabel;
    CheckBoxInf: TCheckBox;
    CheckBoxSup: TCheckBox;
    CheckBoxInc: TCheckBox;
    GroupBox5: TGroupBox;
    SpeedButton1: TSpeedButton;
    BitBtnAjoutMesureAFOEV: TBitBtn;
    BitBtnEffacerMesureAFOEV: TBitBtn;
    LabeledEditPublicAFOEV: TLabeledEdit;
    Label27: TLabel;
    GroupBox6: TGroupBox;
    SpeedButton2: TSpeedButton;
    LabeledEditPublicVSNET: TLabeledEdit;
    BitBtnEffacerMesureVSNet: TBitBtn;
    BitBtnAjoutMesureVSNet: TBitBtn;
    Label28: TLabel;
    EditObsVSNet: TEdit;
    Label29: TLabel;
    PubliermesureSN: TMenuItem;
    Edit1: TEdit;
    Label30: TLabel;
    LabeledEdit21: TLabeledEdit;
    Label31: TLabel;
    LabeledEdit22: TLabeledEdit;
    LabeledEdit24: TLabeledEdit;
    LabeledEdit25: TLabeledEdit;
    LabeledEdit26: TLabeledEdit;
    LabeledEdit27: TLabeledEdit;
    LabeledEdit28: TLabeledEdit;
    LabeledEdit29: TLabeledEdit;
    Label32: TLabel;
    LabeledEdit30: TLabeledEdit;
    SpeedButton3: TSpeedButton;
    PopupMenu5: TPopupMenu;
    PublierMesureNova: TMenuItem;
    SpinEditMaxiAvant: TSpinEdit;
    Label33: TLabel;
    Label34: TLabel;
    CheckBoxNord: TCheckBox;
    ButtonVarSuivante: TButton;
    GroupBox7: TGroupBox;
    SpeedButton4: TSpeedButton;
    BitBtnAjoutMesureAAVSO: TBitBtn;
    Memo2: TMemo;
    ButtonEffecarMesureAAVSO: TButton;
    Voirdtails2: TMenuItem;
    ButtonPublierMesures: TButton;
    ButtonImportVariable: TButton;
    Misejour1: TMenuItem;
    Apropos1: TMenuItem;
    Apropos2: TMenuItem;
    PopupMenu6: TPopupMenu;
    Zoom1: TMenuItem;
    EditTailleChamp: TEdit;
    Label35: TLabel;
    Etalonsphotomtriques1: TMenuItem;
    LabelTailleChamp: TLabel;
    ButtonEtalon: TButton;
    ButtonAjoutVisible: TButton;
    ButtonPrecedentListe: TButton;
    ButtonSuivantListe: TButton;
    ButtonEtalons: TButton;
    procedure ButtonAgreeClick(Sender: TObject);
    procedure ButtonEffaceVariableCouranteClick(Sender: TObject);
    procedure ButtonExportRRClick(Sender: TObject);
    procedure ButtonNovaeTxtClick(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure ButtonMesuresAFOEVListeClick(Sender: TObject);
    procedure ButtonMesureAFOEVClick(Sender: TObject);
    procedure CheckBoxEstChange(Sender: TObject);
    procedure CheckBoxFiltreLExistantChange(Sender: TObject);
    procedure CheckBoxRefiltrerChange(Sender: TObject);
    procedure CheckConstelChange(Sender: TObject);
    procedure EditMagLimitChange(Sender: TObject);
    procedure EditTailleChampChange(Sender: TObject);

    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);

    procedure LabeledEdit14Change(Sender: TObject);
    procedure LabeledEdit15Change(Sender: TObject);
    procedure LabeledEditObservateurDblClick(Sender: TObject);
    procedure ListBoxAFOEVObsClick(Sender: TObject);

    procedure MenuItem3Click(Sender: TObject);

    procedure Quitter1Click(Sender: TObject);
    procedure LabeledEdit1Change(Sender: TObject);
    procedure LabeledEdit2Change(Sender: TObject);
    procedure LabeledEdit5Change(Sender: TObject);
    procedure LabeledEdit6Change(Sender: TObject);
    procedure LabeledEdit4Change(Sender: TObject);
    procedure LabeledEdit3Change(Sender: TObject);
    procedure ButtonTousTypeClick(Sender: TObject);
    procedure ButtonAucunTypeClick(Sender: TObject);
    procedure ButtonAucuneConstelClick(Sender: TObject);
    procedure ButtonTouteConstelClick(Sender: TObject);
    procedure CheckListBox1Click(Sender: TObject);
    procedure TabSheet2ContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure TabSheet2Show(Sender: TObject);
    procedure ButtonVLPClick(Sender: TObject);
    procedure ButtonMiraClick(Sender: TObject);
    procedure ButtonVCPClick(Sender: TObject);
    procedure ButtonRRLyraeClick(Sender: TObject);
    procedure ButtonRechercheGCVSClick(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure Affiche_Variable(Sender: TObject ; i : integer);
    procedure ButtonFiltrerClick(Sender: TObject);
    procedure BitBtnExportVariableClick(Sender: TObject);
    procedure TabSheet3ContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure Voirdtails1Click(Sender: TObject);
    procedure Configurer1Click(Sender: TObject);
    procedure ButtonRecupSNHttpClick(Sender: TObject);
    function  DownloadFileHttp(const fileURL,FileName: string):Boolean ;
    procedure Sauverconfig1Click(Sender: TObject);
    procedure SauverConfig;
    procedure ButtonExportSN_PrismClick(Sender: TObject);
    procedure ButtonRechAAVSOClick(Sender: TObject);
    procedure PopupMenu3Popup(Sender: TObject);
    procedure Voirchamp1Click(Sender: TObject);
    procedure Voirchamp2Click(Sender: TObject);
    procedure ReglageLangage;
    procedure TabSheet6Show(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Effacer1Click(Sender: TObject);
    procedure Effacer4Click(Sender: TObject);
    procedure ButtonRecupGEOSClick(Sender: TObject);
    procedure ButtonRecupNovaeClick(Sender: TObject);
    procedure ListView4Compare(Sender: TObject; Item1, Item2: TListItem;
      Data: Integer; var Compare: Integer);
    procedure ButtonImportAFOEVClick(Sender: TObject);
    procedure ButtonRAZClick(Sender: TObject);
    procedure ButtonNovaePrismClick(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure CheckBoxInfClick(Sender: TObject);
    procedure CheckBoxSupClick(Sender: TObject);
    procedure CheckBoxIncClick(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure BitBtnEffacerMesureAFOEVClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Publiermesures1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure PubliermesureSNClick(Sender: TObject);
    procedure TabSheet7Show(Sender: TObject);
    procedure RadioGroup3Click(Sender: TObject);
    procedure BitBtnEffacerMesureVSNetClick(Sender: TObject);
    procedure BitBtnAjoutMesureAFOEVClick(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure PublierMesureNovaClick(Sender: TObject);
    procedure LabeledEditObservateurChange(Sender: TObject);
    procedure EditObsVSNetChange(Sender: TObject);
    procedure SpinEditMaxiAvantChange(Sender: TObject);
    procedure CheckBoxNordClick(Sender: TObject);
    procedure ButtonVarSuivanteClick(Sender: TObject);
    procedure LabeledEdit7Change(Sender: TObject);
    procedure Voirdtails2Click(Sender: TObject);
    procedure ButtonPublierMesuresClick(Sender: TObject);
    procedure TabSheet3Show(Sender: TObject);
    procedure ButtonImportVariableClick(Sender: TObject);
    procedure Apropos1Click(Sender: TObject);
    procedure Misejour1Click(Sender: TObject);
    procedure Zoom1Click(Sender: TObject);
    procedure ButtonEtalonClick(Sender: TObject);
    procedure ButtonAjoutVisibleClick(Sender: TObject);
    procedure ButtonPrecedentListeClick(Sender: TObject);
    procedure ButtonSuivantListeClick(Sender: TObject);
    procedure ButtonEtalonsClick(Sender: TObject);

  private
    { Déclarations privées }
  public
    { Déclarations publiques }
  end;
  variable = packed record
     visible : boolean;
     Constellation : integer;
     Designation : string;
     ADH,ADM,ADS,DCD,DCM,DCS,alpha,delta : real;
     Type_variable : string;
     MaxType : boolean;
     Maximum, Minimum,Min2 : real;
     Epoque,Periode : real;
     YearNova : real;
     TypeSpectral : string;
     Reference1,Reference2 : string[5];
     Updated : boolean;
  end;
  T_sn = packed record
     nom,galaxie,date,alpha,delta,offsets,mag,sn_type,decouvreur : string;
     magnitude : real;
  end;
  p_variable = ^variable;
  T_GCVS = array[1..max_GCVS] of P_variable;
  T_Constellation = array[1..88] of record
     nom : string;
     Checked : boolean;
  end;
  p_sn = ^T_sn;
  T_cat_sn = array[1..10000] of p_sn;

var
  Form1: TForm1;
  GCVS : T_GCVS;
  indexGCVS : P_Table;
  GCVS_Size,GCVS_courant,SN_Size,Novae_Size : integer;
  ForceGEOS,KeepGEOS,VariableCarteNordEHaut,ModeExpert,Acknowledgment_Agree : boolean;

  Table_Constellation : T_Constellation;
  sn,novae : T_Cat_sn;

  Fic_GCVS,Fic_Constel,Rep_AAVSO,Rep_ReqAAVSO,Rep_ReqAFOEV ,
  URL_sn,URL_GCVS,langage,URL_novae,Fic_RapportAFOEV,
  Rapport_Obs_AFOEV,Rapport_Obs_VSNet,RepertoireInitial : Widestring;
  mesg : array[1..100] of PChar;        // PWidechar -> string
  Tabsheet_init : integer;
implementation

{$IFDEF MSWINDOWS}
uses
    Unit3,Unit4,Unit5,Unit6,Unit7,Unit8,Unit9,Unit10;
{$ELSE}
uses
    LCLtype,SysUtils,Unit3,Unit4,Unit5,Unit6,Unit7,Unit8,Unit9,Unit10;
{$ENDIF}


{$R *.lfm}
{$IFDEF LINUX}
function GetTickCount: cardinal;
begin
  Result := QWord(Trunc(Now * 24 * 60 * 60 * 1000));
end;
{$ENDIF}

procedure Delay(AMSecs: Cardinal);
var
  iStop : cardinal;
begin
  iStop := GetTickCount + AMsecs;
  while GetTickCount < iStop do
  begin
    Application.ProcessMessages;
    sleep(1);
  end
end;

function JourJulien(jour,mois,annee : integer):real;
(*
   d'apres Astronomie Pratique et informatique p 221
   Il s'agit de la date julien à 12h sans tenir compte de la reforme
   gregorienne
*)
var
   N : real;
begin

      N:=367.0*Annee-trunc(7.0/4.0*(trunc((Mois+9)/12.0)+Annee))-trunc(3.0/4.0*
         (1+trunc((trunc((Mois-9)/7.0)+Annee)*0.01)))+
          trunc(275.0*Mois/9.0)+jour;
   JourJulien:=N+1721028.5;
end;
function Nom_de_filtre(code : char) : string;
var
   nf :  string;
begin
  case code of
    ' ' :  nf:='Visual      ';
    'A' :  nf:='Photovisual ';
    'B' :  nf:='Photographic';
    'C' :  nf:='panchro.film';
    'D' :  nf:='color film  ';
    'E' :  nf:='image intens';
    'F' :  nf:='PE  U-band  ';
    'G' :  nf:='PE  B-band  ';
    'H' :  nf:='PE  V-band  ';
    'J' :  nf:='PE  R-band  ';
    'K' :  nf:='PE  I-band  ';
    'L' :  nf:='CCD U-band  ';
    'M' :  nf:='CCD B-band  ';
    'N' :  nf:='CCD V-band  ';
    'O' :  nf:='CCD R-band  ';
    'P' :  nf:='CCD I-band  ';
    'Q' :  nf:='CCD Clear   ';
    'R' :  nf:='PE  Clear   ';
    'S' :  nf:='CCD V est.  ';
    'X' :  nf:='Mech.photom.'
    else   nf:='            ';
  end;
  Nom_de_filtre:=nf
end;
procedure TForm1.ReglageLangage;
begin
   mesg[7]:='G''ngSeNG Version 1.6.1 - 08/02/2021';
   if langage='FR' then
   begin
      mesg[1]:='Fichier ginseng.ini manquant. Initialisation des constantes par défaut.';
      mesg[2]:='Lecture de la base GCVS. Attendez...';
      mesg[3]:=' variables lues.';
      mesg[4]:='Base GCVS manquante. Veuillez le récupérer et/ou configurer le chemin d''accès (Fichier/Configurer)';
      mesg[5]:='Fichier constellation.csv manquant. Désolé, je ne peux continuer.';
      mesg[6]:='nconvert.exe pas trouvé';
      mesg[8]:='Etoile variable non trouvée dans la base GCVS';
      mesg[9]:='Le fichier existe. Ecraser (si Non ajouter) ?';
      mesg[10]:='Liste de variables du GCVS';
      mesg[11]:='Utiliser le fichier SN/Novae existant ?';
      mesg[12]:='Impossible de sauver la configuration.';
      mesg[13]:='référence de l''image de ';
      mesg[14]:=' non trouvée.';
      mesg[15]:='Le changement de configuration nécessite un redémarrage de l''application.';
      mesg[16]:='Vous disposez de la dernière version. Merci.';
      mesg[17]:=' est disponible. Merci.';
      mesg[18]:='Il n''y a pas d''étalon sur cette carte de champ. Désolé';
      mesg[19]:=' étalon trouvé sur la carte du champ.';
      mesg[20]:=' étalons trouvés sur la carte du champ.';
      mesg[21]:=' variables de type RR Lyr trouvée(s).';
      mesg[22]:=' non trouvée au GEOS';
      mesg[23]:=' Utiliser le ficher des étalons actuel ?';
      mesg[24]:='Liste des mesures de variables';
      mesg[25]:='Mesures concernant ';
      mesg[26]:='Aucune mesure n''est disponible.';
      mesg[27]:='Base GCVS trop ancienne. Veuillez récupérer la version 2013 de la base avant de re-exécuter Ginseng.';
   end;
   if langage='EN' then
   begin
{ TODO -ctraduction : Rajouter les messages en anglais des dernières nouveautés }
      Form2.Caption:='Reading GCVS database...';
{      Form7.Caption:='Requests';
      Form8.Caption:='About / License';  }

      mesg[1]:='ginseng.ini file missing. Initialisation with default values.';
      mesg[2]:='Reading the GCVS base. Wait...';
      mesg[3]:=' variables read.';
      mesg[4]:='GCVS datafile not found. You have to download it and/or configure the path (File/Configure)';
      mesg[5]:='constellation.csv file missing. Sorry, imposible to continue.';
      mesg[6]:='nconvert.exe not found';
      mesg[8]:='Variable star not found within the GCVS database.';
      mesg[9]:='File already existing. Overwrite (if No append) ?';
      mesg[10]:='Liste of GCVS variable stars';
      mesg[11]:='Use existing local SN/Novae file ?';
      mesg[12]:='Unable to save the configuration.';
      mesg[13]:='Reference of ';
      mesg[14]:='''s picture not found';
      mesg[15]:='To take effect, save the new configuration and restart the application.';
      mesg[16]:='You are using the last version of g''nseng. Thank you.';
      mesg[17]:=' is available. Thank You.';
      mesg[18]:='There is no photometric standard star on this chart. Sorry.';
      mesg[19]:=' standard star found on this chart.';
      mesg[20]:=' standard stars found on this chart.';
      mesg[21]:=' RR Lyrae variable(s) found.';
      mesg[22]:=' not found at GEOS.';
      mesg[23]:=' Use present standard star file for this variable ?';
      mesg[24]:='Liste of measures of variables';
      mesg[25]:='Measures for ';
      mesg[26]:='No measure has been found in the AFOEV database.';
      mesg[27]:='GCVS DataBase too old. Please download version dated 2013 of the database before reexcecute Ginseng.';

      TabSheet1.Caption:='Filters';
      TabSheet2.Caption:='GCVS';
      TabSheet5.Caption:='Extrag. Novae';
      TabSheet7.Caption:='Report';
      TabSheet8.Caption:='Acknowledgments';

      LabeledEdit1.EditLabel.Caption:='Mag at maximum > ';
      LabeledEdit2.EditLabel.Caption:='Mag at minimum < ';
      LabeledEdit5.EditLabel.Caption:='R.A. maximum';
      LabeledEdit6.EditLabel.Caption:='R.A. minimum';
      LabeledEdit4.EditLabel.Caption:='Declination max';
      LabeledEdit4.Hint:='degrees';
      LabeledEdit3.EditLabel.Caption:='Declination min';
      LabeledEdit3.Hint:='degrees';
      LabeledEdit19.EditLabel.Caption:='Periode max';
      LabeledEdit20.EditLabel.Caption:='Periode min';
      Label23.Caption:='To consider variables with AAVSO or AFOEV request and filters, set filters first then go directly to GCVS tabsheet, clic on AFOEV/AAVSO RFO.'; 
      ButtonAucunType.Caption:='None';
      ButtonTousType.Caption:='All';
      ButtonAucuneConstel.Caption:='None';
      ButtonTouteConstel.Caption:='All';
      CheckTypeVar.Caption:='on Variable type';
      CheckConstel.Caption:='on Constellation';
      ButtonVLP.Caption:='Long P.Var';
      ButtonVCP.Caption:='Short P.Var.';
      ButtonFiltrer.Caption:='Filter...';
      CheckBoxRefiltrer.Caption:='Add to present list';
      CheckboxFiltreLExistant.Caption:='Filter present list';
      CheckMag2ndMin.Caption:='presence of a second minima';

      Label2.Caption:='Star   Constel Variable  Maximum Minimum   Periode      Epoque    Right.Asc.   Declinat.   Spectral';
      Label1.Caption:='Name   lation    Type     (mag)   (mag)    (days)       (24...)    h  m  s     °  ''  "     Type';
      ButtonRAZ.Caption:='Clear list';
      ButtonImportAFOEV.Caption:='AFOEV / AAVSO RFO';

      Label15.Caption:='Star   Constel  RR Lyr   Maximum Minimum   Periode      Epoque    Right.Asc.   Declinat.   Next';
      Label16.Caption:='Name   lation    Type     (mag)   (mag)    (days)       (24...)    h  m  s     °  ''  "     Maximum';
      Label19.Caption:='U.T.';
      Label33.Caption:='Maxi within ';
      Button3.Caption:='Now';
      Button3.Hint:='Set Next Maximum search date to Now';
      Button4.Caption:='Update maximums on list';
      Button5.Caption:='Add obj. (Tarot)';
      Button5.Hint:='Add objects from plain list (Tarot Calern)';
      ButtonRecupGEOS.Caption:='Update elements...';
      ButtonRecupGEOS.Hint:='Update RR Lyr elements from GEOS database';

      LabeledEdit7.EditLabel.Caption:='Search variable (i.e. XX And) :';
      LabeledEdit7.Hint:='Designation/Name of variable star to search';
      LabeledEdit8.EditLabel.Caption:='Name of variable :';
      LabeledEdit10.EditLabel.Caption:='Spectral Type :';
      LabeledEdit14.EditLabel.Caption:='Right Ascension :';
      LabeledEdit15.EditLabel.Caption:='Declination :';
      LabeledEdit16.EditLabel.Caption:='Periode (day) :';
      CheckBoxNord.Caption:='North Up';
      CheckBoxEst.Caption :='East left';
      LabelTailleChamp.Caption:='Field :';
      Panel1.Caption:='No FOV Chart available from AAVSO.';
      Button1.Caption:='Search in GCVS...';
      BitBtn2.Caption:='Previous in GCVS';
      BitBtn3.Caption:='Next in GCVS';
      ButtonPublierMesures.Caption:='Publish measures...';
      ButtonRechAAVSO.Caption:='Search AAVSO Chart...';
      ButtonEtalon.Caption:='Photometric Standard...';
      ButtonAjoutVisible.Caption:='Add to list';
      ButtonPrecedentListe.Caption:='Previous in list';
      ButtonSuivantListe.Caption:='Next in list';
      ButtonMesureAFOEV.Caption:='AFOEV Measures';
      ButtonMesuresAFOEVListe.Caption:='AFOEV Measures';
      ButtonEffaceVariableCourante.Caption:='Clear';
      LabelMagLimite.Caption:='Limiting. Mag';
      LabelTailleChamp.Caption:='Field Size';

      LabeledEditMagSNLimite.EditLabel.Caption:='Use limiting mag.';
      LabeledEditMagSNLimite.Hint:='Give limiting mag. for SN search';
      LabeledEditSeparation.EditLabel.Caption:='Separation';
      LabeledEditSeparation.Hint:='Give minimal separation for SN search';
      Label4.Caption:='Date for SN after :';
      CheckBoxAlphaSN.Caption:='Use R.A. criteria';
      CheckBoxDeltaSN.Caption:='Use Decl. criteria';
      CheckBoxAlphaSN.Hint:='(see Filters)';
      CheckBoxDeltaSN.Hint:='(see Filters)';
      ButtonRecupSNHttp.Caption:='Update (Weizmann TNS)';
      ButtonRecupSNHttp.Hint:='downloaded from CBAT web site';
      ButtonExportSN_Prism.Caption:='Export List for PRISM';
      Label5.Caption:='Name of   Host Galaxy     Date of    Right Ascens. Declination  Sep. Magni-    SN     Discovered by';
      Label6.Caption:='Supernova                Discovery   ( HH MM SS )  (DD.MM.SS)   (")   tude    Type';

      Label20.Caption:='Date for Novae after :';
      LabeledEditMagNovaeLimite.EditLabel.Caption:='Use limiting mag.';
      LabeledEditMagNovaeLimite.Hint:='Give limiting mag. for extragalactic Novae search';
      CheckListBoxNovae.Hint:='Select host galaxies';
      ButtonRecupNovae.Caption:='Update List';
      ButtonRecupNovae.Hint:='downloaded from CBAT web site';
      Label21.Caption:='Date           Nova     Host        Right Ascens. Declination    Magni-';
      Label22.Caption:='Discov.        Name     Galaxy       (HH MM SS )  (DD.MM.SS)      tude';

      Groupbox2.Caption:=' Observer ';
      GroupBox3.Caption:='Civilian Date : ';
      GroupBox4.Caption:='Julian Date : ';
      GroupBox5.Caption:='AFOEV Publication Data : ';
      GroupBox6.Caption:='VSNet Publication Data : ';
      LabeledEditVariablePublic.EditLabel.Caption:='Object name : ';
      ButtonVarSuivante.Caption:='Next Object';
      RadioGroup3.Caption:='Date Type : ';
      RadioGroup3.Items[0]:='Civilian';
      RadioGroup3.Items[1]:='Julian';
      LabeledEditObservateur.EditLabel.Caption:='Observer Code : ';
      LabelPosition.Caption:='Location : ';
      RadioGroup1.Items[0]:='Visual';
      RadioGroup2.Caption:='Filters';
      RadioGroup2.Items[0]:='Clear';
      RadioGroup2.Items[7]:='Green BRT';
      Label24.Caption:='Date (YYYY/MM/DD)';
      Label25.Caption:='Time (U.T.) : ';
      CheckBoxInf.Caption:='inferior value (<)';
      CheckBoxSup.Caption:='superior value (>)';
      CheckBoxInc.Caption:='uncertain value (:)';

      LabeledEditPublicAFOEV.EditLabel.Caption:='Edit zone : ';
      BitBtnAjoutMesureAFOEV.Caption:='Add mesure to AFOEV report';
      BitBtnEffacerMesureAFOEV.Caption:='Clear';
      LabeledEditPublicVSNet.EditLabel.Caption:='Edit zone : ';
      BitBtnAjoutMesureVSNet.Caption:='Add mesure to VSNET report';
      BitBtnEffacerMesureVSNet.Caption:='Clear';

      MainMenu1.Items.Items[0].Caption:='File';
      MainMenu1.Items.Items[2].Caption:='About...';
      Fichier1.Items[0].Caption:='Settings...';
      Fichier1.Items[1].Caption:='Save settings';
      Fichier1.Items[2].Caption:='Exit';
      Apropos2.Items[0].Caption:='License...';
      Apropos2.Items[1].Caption:='Updates...';

      PopupMenu1.Items[0].Caption:='Delete from list';
      PopupMenu1.Items[1].Caption:='Show details...';
      PopupMenu1.Items[2].Caption:='Publish measures...';

      PopupMenu2.Items[0].Caption:='Show details...';

      PopupMenu3.Items[0].Caption:='See AAVSO field...';
      PopupMenu3.Items[1].Caption:='See Odd Trondall reference...';
      PopupMenu3.Items[2].Caption:='Publish measures...';

      PopupMenu5.Items[0].Caption:='Publish measures...';
      PopupMenu6.Items[1].Caption:='Photometric stars...';
   end
end;

procedure Decode_variable(buffer : string ; var variable : p_variable);
var
   code : integer;
begin
   with variable^ do
   begin
     Val(Trim(Copy(buffer,1,2)),Constellation,code);
     Designation:=Trim(Copy(buffer,9,5));
     Val(Trim(Copy(buffer,21,2)),ADH,code);
     Val(Trim(Copy(buffer,23,2)),ADM,code);
     Val(Trim(Copy(buffer,25,4)),ADS,code);
     Val(Trim(Copy(buffer,30,2)),DCD,code);
     Val(Trim(Copy(buffer,32,2)),DCM,code);
     Val(Trim(Copy(buffer,34,2)),DCS,code);
     if Copy(buffer,29,1)='-' then begin
        DCD:=-DCD;
        DCM:=-DCM;
        DCS:=-DCS;
     end;
     alpha:=ADH+ADM/60+ADS/3600;
     delta:=DCD+DCM/60+DCS/3600;
{     ADH,ADM,ADS,DCD,DCM,DCS : real; }
     Type_variable:=Trim(Copy(buffer,38,10));
     Val(Trim(Copy(buffer,108,16)),Periode,Code);
{     MaxType : boolean; }
     Maximum:=0;
     Minimum:=0; Min2:=0;  Epoque:=0; YearNova:=0;
     Val(Trim(Copy(buffer,50,6)),Maximum,code);
     Val(Trim(Copy(buffer,60,6)),Minimum,code);
     If Copy(Buffer,59,1)='(' then Minimum:=Minimum+Maximum;

     Val(Trim(Copy(buffer,74,6)),Min2,code);
     If Copy(Buffer,72,1)='(' then Min2:=Min2+Maximum;


     Val(Trim(Copy(buffer,88,11)),Epoque,code);
     Val(Trim(Copy(buffer,101,4)),YearNova,code);

{
     Epoque : real;
     YearNova : real;
}
     TypeSpectral:=Trim(Copy(buffer,134,17));
     Visible:=false;
   end;
end;

procedure decoupe_blanc(t : string; var g,d : string);
   // cette procedure retourne les deux sous-chaines de t séparées par un blanc
   var
      i,l : integer;
      s : string;
   begin
      s:=Trim(t);
      l:=length(s);
      if l>1 then
      begin
         i:=0;
         repeat
            inc(i)
         until (s[i]=' ') or (i=l);
         d:='';
         g:='';
         if i>1 then g:=Copy(s,1,i);
         if i<l then d:=Copy(s,i+1,l-i);
      end;
      g:=Trim(g);
      d:=Trim(d);
   end;

procedure TForm1.FormDestroy(Sender: TObject);
var
   i : integer;
   f_geos : Textfile;
begin

   if KeepGEOS then
   begin
      AssignFile(f_geos,'GEOS_RRLyr.data');
      Rewrite(f_geos);
   end;
   for i:=1 to GCVS_Size do
      begin
         With GCVS[i]^ do
            if Updated and keepGEOS then
               Writeln(f_geos,Designation:6,Table_Constellation[GCVS[i]^.Constellation].nom,' ',Epoque,' ',Periode,' ',Maximum,' ',Minimum);
         Dispose(GCVS[i]);
         Dispose(indexGCVS^[i]);
      end;
   Dispose(indexGCVS);
   for i:=1 to SN_Size do
      begin
         Dispose(sn[i]);
      end;
   if KeepGEOS then CloseFile(f_GEOS);
end;

procedure TForm1.ButtonMesureAFOEVClick(Sender: TObject);

var
   Server_ftpAFOEV,File_ftpAFOEV,Filename_AFOEV, Port_ftp : string;
   buffer,code_observateur_mesure,nom_observateur,filtre,dummy1,dummy2 : String;
   i : integer;
   FTPClient:TFTPSend;
   f_AFOEV : TextFile;
   nf      : char;
begin

   ButtonMesureAFOEV.Enabled:=False;

   with GCVS[GCVS_courant]^ do
      Server_ftpAFOEV:='cdsarc.u-strasbg.fr';

   with GCVS[GCVS_courant]^ do
   begin

      File_ftpAFOEV:='/pub/afoev/'+Lowercase(Table_Constellation[Constellation].nom)+'/'+Lowercase(designation);
      FileName_AFOEV :='mesures_AFOEV.txt';
      Port_ftp :='21';

      if FtpGetFile(Server_ftpAFOEV, Port_ftp, File_ftpAFOEV, FileName_AFOEV,'anonymous','marc.serrau@free.fr') then

      begin
// Filetransfer successful
         AssignFile(f_afoev,'mesures_AFOEV.txt');
         Reset(f_afoev);
         Form3.Memo1.Lines.Clear;
         repeat
            readln(f_afoev,buffer);
            code_observateur_mesure:=copy(buffer,1,3);
            // Recherche du nom de l'observateur :
            nom_observateur:='';
            for i:=0 to ListBoxAFOEVObs.Count-1 do
            begin
               dummy1:=copy(ListBoxAFOEVObs.Items[i],31,3);
               dummy2:=copy(ListBoxAFOEVObs.Items[i],1,30);
               if code_observateur_mesure=dummy1 then nom_observateur:=Trim(dummy2);
            end;
            if nom_observateur='' then nom_observateur:=code_observateur_mesure;
            nf:=buffer[14];
            Filtre:=Nom_de_filtre(nf);
            Form3.Memo1.Append(copy(buffer,4,10)+'  '+copy(buffer+'   ',15,6)+' '+Filtre+' '+nom_observateur);
         until eof(f_afoev);
         CloseFile(f_afoev);
         IF langage='EN' then
            Form3.Label1.Caption:='AFOEV Measures of '
         else
            Form3.Label1.Caption:='Mesures AFOEV de ';
         Form3.Label1.Caption:=Form3.Label1.Caption+designation+' '+Table_Constellation[Constellation].nom;
         Form3.Show;
      end
      else
         With Application do MessageBox(Pchar(file_ftpAFOEV+' NOT downloaded from '+Server_ftpAFOEV{+' '+IntToStr(TFTPClient.ErrorCode) + ' - ' + TFTPClient.ErrorString}),'',MB_Ok);
      ButtonMesureAFOEV.Enabled:=True;
   end;
end;

procedure TForm1.CheckBoxEstChange(Sender: TObject);
begin

end;

procedure TForm1.CheckBoxFiltreLExistantChange(Sender: TObject);
begin
   if CheckBoxFiltreLExistant.checked then CheckBoxRefiltrer.checked:= false
end;

procedure TForm1.CheckBoxRefiltrerChange(Sender: TObject);
begin
   if CheckBoxRefiltrer.checked then CheckBoxFiltreLExistant.checked:= false
end;

procedure TForm1.CheckConstelChange(Sender: TObject);
begin

end;

procedure TForm1.EditMagLimitChange(Sender: TObject);
var
   mag : real;
   code : integer;
begin
   Val(Trim(EditMagLimit.Text),mag,code);
   if code=0 then EditMagLimit.Font.Color:=clBlack else EditMagLimit.Font.Color:=clRed
end;

procedure TForm1.EditTailleChampChange(Sender: TObject);
var
   champ : real;
   code : integer;
begin
   Val(Trim(EditTailleChamp.Text),champ,code);
   if code=0 then EditTailleChamp.Font.Color:=clBlack else EditTailleChamp.Font.Color:=clRed
end;

procedure TForm1.ButtonMesuresAFOEVListeClick(Sender: TObject);
begin
    MenuItem3Click(Sender);
end;

procedure TForm1.Button7Click(Sender: TObject);
var
   i : integer;
   reponse : longint;
   f_exp : TextFile;
   AD,DC : string;
begin

   if SaveDialog1.Execute then
   begin
      reponse:=IDYES;
      AssignFile(f_exp,SaveDialog1.FileName);
      {$I-}Reset(f_exp); {$I+}
      If IOResult=0 then
      begin
         reponse:=Application.MessageBox(PChar(mesg[9]),'',MB_YESNOCANCEL);
         closefile(f_exp);
      end;
      AssignFile(f_exp,SaveDialog1.FileName);
      case reponse of
      IDYes : Rewrite(f_exp);
      IDNo  : Append(f_exp);
      end;
      if reponse<>IDCANCEL then
      begin
         Writeln(f_exp,'Nom        Galaxie         Date        Ascens.Droite Déclinaison    Sép. Magni-   Type    Découvreur');
         Writeln(f_exp,'Supernova  hôte            Découverte   ( HH MM SS )  (DD.MM.SS)    (")   tude     SN');
         Writeln(f_exp,'');

         For i:=1 to SN_Size do
            With SN[i]^ do
               begin
                  with SN[i]^ do
                  begin
                     AD:=Copy(Alpha,1,2)+'h'+Copy(Alpha,4,2)+'m'+Copy(Alpha,7,4)+'s';
                     DC:=Copy(Delta,1,3)+Char(248)+Copy(Delta,5,2)+''''+Copy(Delta,8,4)+'''''';
                     Writeln(f_exp,Copy(nom+'        ',1,10),' ',Copy(galaxie+'                    ',1,15),' ',date:10,
                                '   ',AD,'  ',DC,' ',offsets:4,'   ',magnitude:4:1,'     ',sn_type:5,'  ',decouvreur);
                  end;
               end;
         Closefile(f_exp);
      end;
   end;

end;

procedure TForm1.ButtonNovaeTxtClick(Sender: TObject);
var
   i : integer;
   reponse : longint;
   f_exp : TextFile;
   AD,DC : string;
begin

   if SaveDialog1.Execute then
   begin
      reponse:=IDYES;
      AssignFile(f_exp,SaveDialog1.FileName);
      {$I-}Reset(f_exp); {$I+}
      If IOResult=0 then
      begin
         reponse:=Application.MessageBox(mesg[9],'',MB_YESNOCANCEL);
         closefile(f_exp);
      end;
      AssignFile(f_exp,SaveDialog1.FileName);
      case reponse of
      IDYes : Rewrite(f_exp);
      IDNo  : Append(f_exp);
      end;
      if reponse<>IDCANCEL then
      begin
         Writeln(f_exp,'Date          Galaxie            Ascens.Droite Declinaison  Magni-' );
         Writeln(f_exp,'Decouverte    Hote     Nova       (HH MM SS )  (DD.MM.SS)   tude   Type');
         Writeln(f_exp);
         For i:=1 to Novae_Size do
            With Novae[i]^ do
               begin
{
00h42m44.75s
+41°15'11.9"
}
                  AD:=Copy(Alpha,1,2)+'h'+Copy(Alpha,4,2)+'m'+Copy(Alpha,7,2)+'s';
                  DC:=Copy(Delta,1,3)+'d'+Copy(Delta,5,2)+''''+Copy(Delta,8,2)+'''''';
                  Writeln(f_exp,Copy(date+'          ',1,12),'  ',Copy(galaxie+'           ',1,8),' ',Copy(nom+'        ',1,10),
                                '  ',AD,'   ',DC,'  ',Copy(mag+'    ',1,4),'   Nova Extragalactique');

               end;
         Closefile(f_exp);
      end;
   end;



end;

procedure TForm1.ButtonExportRRClick(Sender: TObject);
var
   f_exp : textfile;
   i,l,RRIndex,reponse : longint;
   RRVariable,ligne,svar,bufAD,bufDC : String;
begin
   l:=ListView3.Items.Count;
   case Application.MessageBox('Export PRISM ?','',MB_YESNOCANCEL) of
   IDNo :
       if SaveDialog1.Execute then   { Export Neutre }
       begin
          reponse:=IDYES;
          AssignFile(f_exp,SaveDialog1.FileName);
          {$I-}Reset(f_exp); {$I+}
          If IOResult=0 then
          begin
             reponse:=Application.MessageBox(PChar(mesg[9]),'',MB_YESNOCANCEL);
             closefile(f_exp);
          end;
          AssignFile(f_exp,SaveDialog1.FileName);
          case reponse of
          IDYes : begin
             Rewrite(f_exp);
             Writeln(f_exp,Label15.Caption);
             Writeln(f_exp,Label16.Caption);
             Writeln(f_exp);
          end;
          IDNo  : Append(f_exp);
          end;
          if reponse<>IDCANCEL then
          begin
             For i:=0 to l-1 do
                Writeln(f_exp,ListView3.Items[i].Caption);

             Closefile(f_exp);
          end;
       end;
    IDYes :
       if SaveDialog1.Execute then      // Export Prism
       begin
          reponse:=IDYES;
          AssignFile(f_exp,SaveDialog1.FileName);
          {$I-}Reset(f_exp); {$I+}
          If IOResult=0 then
          begin
             reponse:=Application.MessageBox(Pchar(mesg[9]),'',MB_YESNOCANCEL);
             closefile(f_exp);
          end;
          AssignFile(f_exp,SaveDialog1.FileName);
          case reponse of
          IDYes : Rewrite(f_exp);
          IDNo  : Append(f_exp);
          end;
          if reponse<>IDCANCEL then
          begin
             For i:=0 to l-2 do
             begin
                Ligne:=ListView3.Items[i].Caption;
                RRVariable:=Trim(Copy(Ligne,8,3))+Trim(Copy(Ligne,1,7))+' ';
                RRIndex:=RechercheIndex(indexGCVS,GCVS_size,RRVariable);
                If RRIndex>0 then
                begin
                   With GCVS[RRIndex]^ do
                   begin
                      Str(ADH:2:0,svar);
                      bufAD:=svar+'h';
                      Str(ADM:2:0,svar);
                      bufAD:=bufAD+svar+'m';
                      Str(ADS:6:3,svar);
                      bufAD:=bufAD+svar+'s';

                      Str(abs(DCD):2:0,svar);
                      bufDC:=svar+Char(248);  if Delta>0 then bufDC:='+'+bufDC else bufDC:='-'+bufDC;
                      Str(abs(DCM):2:0,svar);
                      bufDC:=bufDC+svar+'''';
                      Str(abs(DCS):5:2,svar);
                      bufDC:=bufDC+svar+'''''';

                      bufAD:= StringReplace(bufAD,' ','0',[rfReplaceAll]);
                      bufDC:= StringReplace(bufDC,' ','0',[rfReplaceAll]);


                      Writeln(f_exp,'"',designation,' ',Table_Constellation[constellation].nom,
                                    '"  ',bufAD,'  ',bufDC,'  ',Maximum:4:1,'  FALSE  ','"',Type_variable,'"');

                   end;
                end;
             end;
             Closefile(f_exp);
          end;
       end;

    end;

end;

procedure TForm1.ButtonEffaceVariableCouranteClick(Sender: TObject);
begin

  LabeledEdit8.Text:='';
  LabeledEdit9.Text:='';
  LabeledEdit12.Text:='';
  LabeledEdit13.Text:='';
  LabeledEditMin2.Text:='';
  LabeledEdit14.Text:='';
  LabeledEdit15.Text:='';
  LabeledEdit11.Text:='';
  LabeledEdit16.Text:='';
  LabeledEdit10.Text:='';
  ButtonPublierMesures.Enabled:=false;
  ButtonRechAAVSO.Enabled:=false;
  ButtonEtalon.Enabled:=false;
  ButtonMesureAFOEV.Enabled:=false;
  ButtonAjoutVisible.Enabled:=false;
end;

procedure TForm1.ButtonAgreeClick(Sender: TObject);
begin
  Acknowledgment_Agree:=true;

  TabSheet1.Enabled:=True;
  TabSheet2.Enabled:=True;
  TabSheet3.Enabled:=True;
  TabSheet4.Enabled:=True;
  TabSheet5.Enabled:=True;
  TabSheet6.Enabled:=True;
  TabSheet7.Enabled:=True;
end;

procedure TForm1.FormCreate(Sender: TObject);

var
   f_gcvs, f_const, f_GEOS,f_afoev,f_index : TextFile;
   buffer,svar,m1,m2    : string;
   {const_nom,}RRVariable : string;
   d                    : TDateTime;
   i,p,Maxi,code,champ,k,
   new_tabsheet_init    : integer;
   l,T0,Pe,EclatMin,
   EclatMax             : real;
   FormatSettings       : TFormatSettings;
   Server_ftpAFOEV,
   File_ftpAFOEV,
   FileName_AFOEV,
   Port_ftp             : string;

   DesVarGEOS : String[6];
   CstVarGEOS : string[3];

begin
// on crée les autres panneaux pour pouvoir les mettre à jour :

   Application.CreateForm(TForm2, Form2);

// Réglages par défaut

   Rep_AAVSO:='C:';
//
   Fic_GCVS:='.\iii.csv';
   URL_sn:='https://wis-tns.weizmann.ac.il/search?&isTNS_AT=yes&format=csv';
   URL_GCVS:='http://www.sai.msu.su/groups/cluster/gcvs/gcvs/iii/iii.dat';
   langage:='FR';
   ForceGEOS:=True;
   KeepGEOS:=True;
   Rep_ReqAFOEV:='C:';
   Rep_ReqAAVSO:='C:';
   URL_novae:='http://www.rochesterastronomy.org/novae.html';
   Fic_RapportAFOEV:='RapportAFOEV.txt';
   RepertoireInitial:=GetCurrentDir+'\';
   Tabsheet_init:=7; { La page des remerciements }
   Acknowledgment_Agree:=false; { valeur par défaut. Sera changé par le fichier ini ou l'appui sur le bouton I agree...}


   TabSheet1.Enabled:=false;
   TabSheet2.Enabled:=false;
   TabSheet3.Enabled:=false;
   TabSheet4.Enabled:=false;
   TabSheet5.Enabled:=false;
   TabSheet6.Enabled:=false;
   TabSheet7.Enabled:=false;
   TabSheet8.Enabled:=True;
{
   On lit la configuration dans ginseng.ini :
}
{$IFDEF MSWINDOWS}
   AssignFile(f_const,RepertoireInitial+'ginseng.ini');
{$ELSE}
   AssignFile(f_const,RepertoireInitial+'ginseng.inix');
{$ENDIF}
   {$I-}Reset(f_const); {$I+}
   If IOResult=0 then
   begin
      repeat
         Readln(f_const,buffer);
         if (buffer[1]<>'#') and (buffer[1]<>'[') and (Pos('=',buffer)<>0) then
         begin
            m1:=Trim(Copy(buffer,1,Pos('=',buffer)-1));
            m2:=Trim(Copy(buffer,Pos('=',buffer)+1,Length(buffer)));

            if (m1='Mode') and (m2='Expert') then ModeExpert:=True else ModeExpert:=False;

            if m1='Rep.AAVSO' then Rep_AAVSO:=m2;
            if m1='Fic.Constel' then Fic_Constel:=m2;
            if m1='Fic.GCVS' then Fic_GCVS:=m2;
            if m1='URL.SN' then URL_sn:=m2;
            if m1='URL.GCVS' then URL_GCVS:=m2;
            if m1='Langage' then langage:=m2;
            if m1='ForceGEOS' then
               if m2='1' then
                  ForceGEOS:=True
               else
                  ForceGEOS:=False;
            If m1='KeepGEOS' then
               if m2='1' then
                  KeepGEOS:=True
               else
                  KeepGEOS:=False;
            if m1='URL.Novae' then URL_Novae:=m2;
            if m1='Rep.ReqAFOEV' then Rep_ReqAFOEV:=PChar(m2);
            if m1='Rep.ReqAAVSO' then Rep_ReqAAVSO:=m2;
            if m1='Rapport.AFOEV.Fichier' then Fic_RapportAFOEV:=m2;
            if m1='Rapport.Obs.AFOEV' then Rapport_Obs_AFOEV:=m2;
            if m1='Rapport.Obs.VSNET' then Rapport_Obs_VSNet:=m2;
            if m1='Variable.Carte.NordEnHaut' then
               if m2='1' then
                  VariableCarteNordEHaut:=True
               else
                  VariableCarteNordEHaut:=False;
            if m1='Variable.Carte.Champ' then
            begin
               Val(m2,champ,code);
               if code=0 then
                  EditTailleChamp.Text:=m2 else EditTailleChamp.Text:='20';
            end;
            if m1='Supernovae.separation' then LabeledEditSeparation.Text:=m2;
            if m1='Supernovae.CheckAlpha' then
               if m2='1' then
                  CheckBoxAlphaSN.Checked:=True
               else
                  CheckBoxAlphaSN.Checked:=False;
            if m1='Supernovae.CheckDelta' then
               if m2='1' then
                  CheckBoxDeltaSN.Checked:=True
               else
                  CheckBoxDeltaSN.Checked:=False;
            if m1='Supernovae.CheckMaglimite' then
               if m2='1' then
                  CheckBoxMagSN.Checked:=True
               else
                  CheckBoxMagSN.Checked:=False;
            if m1='Supernovae.Maglimite' then LabeledEditMagSNLimite.Text:=m2;

            if (m1='Novae.CheckMaglimite') then
               if m2='1' then CheckBoxMagLimiteNovae.Checked:=true
            else
               CheckBoxMagLimiteNovae.Checked:=False;
            if m1='Novae.Maglimite' then LabeledEditMagNovaeLimite.Text:=m2;
            if m1='RRLyrae.DelaiMax' then
            begin
               Val(m2,Maxi,code);
               SpinEditMaxiAvant.Value:=Maxi
            end;
            if m1='TabSheet.Init' then
               Val(m2,new_tabsheet_init,code);
            if m1='Acknowledgment.Agree' then
               if m2='OK' then Form1.ButtonAgreeClick(sender); { on agrée aux conditions d'utilisation }
         end;
      until eof(f_const);
      if Acknowledgment_Agree then tabsheet_init:=new_tabsheet_init;

      // tester le langage
      if (Langage<>'FR') and (Langage<>'EN') then Langage:='FR';
      closefile(f_const)
   end
   else
      With Application do MessageBox(PChar(mesg[1]),'',MB_Ok);

   ReglageLangage;

   Form2.Label1.Caption:=mesg[2];
   Form2.Label1.Visible:=True;
   Form2.Show;

//   AssignFile(f_const,Fic_constel);
//   {$I-}Reset(f_const); {$I+}
//   If IOResult=0 then
   if true then
   begin

       For i:=1 to 88 do
       begin
//          Readln(f_const,p,const_nom);
//          Const_nom:=Copy(Const_nom,3,3);
          With Table_Constellation[i] do
          begin
             Nom:=CheckListBox1.Items.Strings[i-1];
             Checked:=True;
          end;
//          CheckListBox1.Items.Add(const_nom);
          CheckListBox1.Checked[i-1]:=True;
       end;
//       Closefile(f_const);
//       CheckListBox1.Items.EndUpdate;

       AssignFile(f_gcvs,Fic_GCVS);
       {$I-}Reset(f_gcvs); {$I+}
//       AssignFile(f_index,'index_GCVS.txt');
//       Rewrite(f_index);
       If IOResult=0 then
       begin
          i:=0;
          Readln(f_gcvs,buffer);
// on traite le cas du changt de structure de la base en Avril 2013
          if copy(buffer,76,6)<>'Min II' then
          begin
             Form2.Destroy;
             TabSheet1.Enabled:=False;
             TabSheet2.Enabled:=False;
             TabSheet3.Enabled:=False;
             With Application do
             begin
                MessageBox(PChar(mesg[27]),'',MB_OK);
//             Terminate;
             end
          end
          else
          begin
              Readln(f_gcvs,buffer);
              New(indexGCVS);          // on crée le tableau d'indexage de GCVS
              CheckListBox2.Items.BeginUpdate;
              repeat
                 buffer:='';
                 Readln(f_gcvs,buffer);
                 inc(i);
                 New(GCVS[i]);     // on crée les éléments de l'index
                 Decode_variable(buffer,GCVS[i]);
                 with GCVS[i]^ do
                 begin
                    Updated:=false;
                    new(indexGCVS[i]);
                    indexGCVS^[i].value:=Upcase(Table_Constellation[Constellation].nom)+Upcase(Trim(Designation))+' ';
                    indexGCVS^[i].rang:=i;
    //                Svar:=Copy(Designation+'     ',1,5)+Table_Constellation[Constellation].nom+' '+Type_variable+' '+TypeSpectral;
        //            if CheckListBox2.Items.IndexOfName(Type_variable)=-1 then
        //               CheckListBox2.Items.Add(Type_variable);
                 end;
                 l:=100.0*i/41000.0;
                 p:=round(l);
                 Form2.Progressbar1.Position:=p;
              until eof(f_gcvs);
              CheckListBox2.Items.EndUpdate;
              GCVS_courant:=1;
              SortTable(indexGCVS,i); // on tri l'index du GCVS
//              for k:=1 to i do writeln(f_index,indexGCVS^[k].value,' ',indexGCVS^[k].rang);
//              closeFile(f_index);
              Form2.Destroy;
              Form1.Show;

              CheckConstel.Checked:=False;
              CloseFile(f_gcvs);
              GCVS_Size:=i;
              Str(GCVS_Size:6,Svar);
              SVar:=SVar+mesg[3];
              Memo1.Lines.Append(Svar);

              If ForceGEOS then
              begin
                 AssignFile(f_gcvs,Fic_GCVS);



                 AssignFile(f_GEOS,'GEOS_RRLyr.data');
                 {$I-} Reset(f_GEOS); {$I+}
                 If IOResult=0 then
                 begin
                    while not eof(f_GEOS) do
                    begin
                        readln(f_GEOS,DesVarGEOS,CstVarGEOS,T0, Pe, EclatMax, EclatMin);
                        DesVarGEOS:=Trim(DesVarGEOS);
                        RRVariable:=Trim(CstVarGEOS)+Trim(DesVarGEOS)+' ';

                        i:=RechercheIndex(indexGCVS,GCVS_size,RRVariable);
                        if i<>0 then
                           With GCVS[i]^ do
                           begin
                              Epoque:=T0;
                              Periode:=Pe;
                              If EclatMax>0 then Maximum:=EclatMax;
                              If EclatMin>0 then Minimum:=EclatMin;
                              updated:=true;
                           end;
                    end;
                    CloseFile(f_geos);
                 end;
              end
          end
       end else
       begin
          Form2.Destroy;
          TabSheet1.Enabled:=False;
          TabSheet2.Enabled:=False;
          TabSheet3.Enabled:=False;
          With Application do
          begin
             MessageBox(PChar(mesg[4]),'',MB_OK);
//             Terminate;
          end;
       end;
   end ;

   DateTimePicker1.Date:=Today-10;

   with ButtonRechAAVSO do
   begin
      ShowHint:=True;
      Hint:=mesg[6];
   end;

   DateTimePicker2.Date:=Int(Date);
   d:=Time;
   SpinEdit1.Value:=Trunc(24*(D-int(D)));
   SpinEdit2.Value:=Trunc(60*24*(D-Int(d)-SpinEdit1.Value/24));
   SpinEdit3.Value:=YearOf(Date);
   SpinEdit4.Value:=MonthOf(Date);
   SpinEdit5.Value:=DayOf(Date);

   with FormatSettings do
   begin
      LongTimeFormat:='hh:nn:ss';
      TimeSeparator:=':';
   end;
   MaskEditHeure.Text:=TimeToStr(Time,FormatSettings);
   SpeedButton3Click(Sender);
   PageControl1.TabIndex:=Tabsheet_init;

// Recherche des codes des observateurs de l'AFOEV :

   AssignFile(f_afoev,'observer.txt');
   {$I-}Reset(f_afoev); {$I+}
   If IOResult<>0 then
   begin
// Le ficher des observateurs AFOEV est absent, on le récupère via ftp :
      Server_ftpAFOEV:='cdsarc.u-strasbg.fr';


      File_ftpAFOEV:='/pub/afoev/observer';
      FileName_AFOEV :='observer.txt';
      Port_ftp :='21';
      if FtpGetFile(Server_ftpAFOEV, Port_ftp, File_ftpAFOEV, FileName_AFOEV,'anonymous','marc.serrau2@free.fr') then
      begin
      end;

   end
   else closefile(f_afoev);
// on recommence après l'avoir éventuellement récupéré via ftp
   AssignFile(f_afoev,'observer.txt');
   {$I-}Reset(f_afoev); {$I+}
   If IOResult=0 then
   begin
      repeat
         readln(f_afoev,buffer); buffer:=buffer+'                                      ';
         buffer:=Copy(buffer,9,30)+Copy(buffer,1,3);
         ListBoxAFOEVObs.Items.Append(buffer);
      until eof(f_afoev);
      closefile(f_afoev);
   end;

end;


procedure TForm1.LabeledEdit14Change(Sender: TObject);
var
   sa : string;
begin
   sa:=Trim(LabeledEdit14.Text);
   LabeledEdit14.Text:=sa;
   if (sa<>'') and (LabeledEdit15.Text<>'')  then
   begin
      ButtonRechAAVSO.Enabled:=true;
      ButtonEtalon.Enabled:=true;
   end
   else
   begin
      ButtonRechAAVSO.Enabled:=false;
      ButtonEtalon.Enabled:=false;
   end;
end;

procedure TForm1.LabeledEdit15Change(Sender: TObject);
var
   sd : string;
begin
   sd:=Trim(LabeledEdit15.Text);
   LabeledEdit15.Text:=sd;
   if (sd<>'') and (LabeledEdit14.Text<>'') then
   begin
      ButtonRechAAVSO.Enabled:=true;
      ButtonEtalon.Enabled:=true;
   end else
   begin
      ButtonRechAAVSO.Enabled:=false;
      ButtonEtalon.Enabled:=false;
   end;
end;

procedure TForm1.LabeledEditObservateurDblClick(Sender: TObject);
begin
   ListBoxAFOEVObs.Enabled:=true;
   ListBoxAFOEVObs.Visible:=true;
end;

procedure TForm1.ListBoxAFOEVObsClick(Sender: TObject);
begin
  ListBoxAFOEVObs.Visible:=false;
  ListBoxAFOEVObs.Enabled:=false;
  LabeledEditObservateur.text:=Copy(ListBoxAFOEVObs.Items.Strings[ListBoxAFOEVObs.ItemIndex],31,3);
end;

procedure TForm1.MenuItem3Click(Sender: TObject);

var
   Server_ftpAFOEV,File_ftpAFOEV,Filename_AFOEV, Port_ftp : string;
   buffer,code_observateur_mesure,nom_observateur,filtre,dummy1,dummy2 : String;
   i,j,nb_download : integer;
//   FTPClient:TFTPSend;
   f_AFOEV : TextFile;
   nf      : char;
   ok_continue : boolean;
   nv : string;

begin
   ButtonMesuresAFOEVListe.Enabled:=false;
   ok_continue:=true;
   nb_download:=0;
   if ListView1.Items.Count-1>5 then
   begin
      Str(ListView1.Items.Count-1:5,nv);
      IF langage='EN' then
         nv:=nv+' variables to retrieve. Sure to continue ?'
      else
         nv:=nv+' variables à retrouver. Vous êtes sûr de continuer ?';
      if Application.MessageBox(PChar(nv),'',MB_YESNOCANCEL)<>IDYes then ok_continue:=false;
   end;
   if ok_continue then
   begin
      Server_ftpAFOEV:='cdsarc.u-strasbg.fr';
      Form3.Memo1.Lines.Clear;
      Form3.Label1.Caption:=Mesg[24];
      for i:=1 to GCVS_Size do
      begin
         if GCVS[i]^.visible then
         begin

           with GCVS[i]^ do
           begin

              File_ftpAFOEV:='/pub/afoev/'+Lowercase(Table_Constellation[Constellation].nom)+'/'+Lowercase(designation);
              FileName_AFOEV :='mesures_AFOEV.txt';
              Port_ftp :='21';

              if FtpGetFile(Server_ftpAFOEV, Port_ftp, File_ftpAFOEV, FileName_AFOEV,'anonymous','marc.serrau@free.fr') then

              begin
        // Filetransfer successful
                 Inc(nb_download);
                 AssignFile(f_afoev,'mesures_AFOEV.txt');
                 Reset(f_afoev);
                 Form3.Memo1.Append(Mesg[25]+designation+' '+Table_Constellation[Constellation].nom);
                 Form3.Memo1.Append('');
                 repeat
                    readln(f_afoev,buffer);
                    code_observateur_mesure:=copy(buffer,1,3);
                    // Recherche du nom de l'observateur :
                    nom_observateur:='';
                    for j:=0 to ListBoxAFOEVObs.Count-1 do
                    begin
                       dummy1:=copy(ListBoxAFOEVObs.Items[j],31,3);
                       dummy2:=copy(ListBoxAFOEVObs.Items[j],1,30);
                       if code_observateur_mesure=dummy1 then nom_observateur:=Trim(dummy2);
                    end;
                    if nom_observateur='' then nom_observateur:=code_observateur_mesure;
                    nf:=buffer[14];
                    Filtre:=Nom_de_filtre(nf);
                    Form3.Memo1.Append(copy(buffer,4,10)+'  '+copy(buffer+'   ',15,6)+' '+Filtre+' '+nom_observateur);

                 until eof(f_afoev);
                 CloseFile(f_afoev);
                 Form3.Memo1.Append('');
              end
//              else
//                 With Application do MessageBox(Pchar(file_ftpAFOEV+' NOT downloaded from '+Server_ftpAFOEV{+' '+IntToStr(TFTPClient.ErrorCode) + ' - ' + TFTPClient.ErrorString}),'',MB_Ok);
           end;
         end;
      end;
      if nb_download=0 then Form3.Memo1.Append(Mesg[26]);
      Form3.Show;
   end;
   ButtonMesuresAFOEVListe.Enabled:=true;
end;

procedure TForm1.Apropos1Click(Sender: TObject);
begin
   Form8.show;
end;

procedure TForm1.Quitter1Click(Sender: TObject);
begin
    Application.Terminate;
end;

procedure TForm1.LabeledEdit1Change(Sender: TObject);
begin
   if LabeledEdit1.Text<>'' then
      CheckMagMax.Checked:=True else CheckMagMax.Checked:=False;
end;

procedure TForm1.LabeledEdit2Change(Sender: TObject);
begin
   if LabeledEdit2.Text<>'' then
      CheckMagMin.Checked:=True else CheckMagMin.Checked:=False;
end;

procedure TForm1.LabeledEdit5Change(Sender: TObject);
begin
   if LabeledEdit5.Text<>'' then
      CheckADMax.Checked:=True else CheckADMax.Checked:=False;
end;

procedure TForm1.LabeledEdit6Change(Sender: TObject);
begin
   if LabeledEdit6.Text<>'' then
      CheckADMin.Checked:=True else CheckADMin.Checked:=False;
end;

procedure TForm1.LabeledEdit4Change(Sender: TObject);
begin
   if LabeledEdit4.Text<>'' then
      CheckDecMax.Checked:=True else CheckDecMax.Checked:=False;
end;

procedure TForm1.LabeledEdit3Change(Sender: TObject);
begin
   if LabeledEdit3.Text<>'' then
      CheckDecMin.Checked:=True else CheckDecMin.Checked:=False;

end;

procedure TForm1.ButtonTousTypeClick(Sender: TObject);
var
   i : integer;
begin
   for i:=0 to CheckListBox2.Count-1 do
      CheckListBox2.Checked[i]:=True;
   CheckTypeVar.Checked:=True;
end;

procedure TForm1.ButtonAucunTypeClick(Sender: TObject);
var
   i : integer;
begin
   for i:=0 to CheckListBox2.Count-1 do
      CheckListBox2.Checked[i]:=False;
   CheckTypeVar.Checked:=False;
end;

procedure TForm1.ButtonAucuneConstelClick(Sender: TObject);
var
   i : integer;
begin
   for i:=0 to CheckListBox1.Count-1 do
   begin
      CheckListBox1.Checked[i]:=False;
      Table_Constellation[i+1].Checked:=False;
   end;
   CheckConstel.Checked:=False;
end;

procedure TForm1.ButtonTouteConstelClick(Sender: TObject);
var
   i : integer;
begin
   for i:=0 to CheckListBox1.Count-1 do
   begin
      CheckListBox1.Checked[i]:=True;
      Table_Constellation[i+1].Checked:=True;
   end;
   CheckConstel.Checked:=True;
end;

procedure TForm1.CheckListBox1Click(Sender: TObject);
var
   i: integer;
begin
   For i:=0 to CheckListBox1.Count-1 do
      Table_constellation[i+1].Checked:=CheckListBox1.checked[i];
end;

procedure TForm1.TabSheet2ContextPopup(Sender: TObject; MousePos: TPoint;
  var Handled: Boolean);
begin

end;

procedure TForm1.TabSheet2Show(Sender: TObject);
var
   i,cpt : integer;
   svar,SPeriode,SEpoque,BufAD,BufDC,nb,SMaxMag,SMinMag : string;
begin
//    Memo1.Lines.Clear;
//    Memo1.Lines.BeginUpdate;

    ListView1.Items.Clear;
    ListView1.Items.BeginUpdate;


    cpt:=0;
    for i:=1 to GCVS_Size do
    begin
//       ch:=True;
//       if checkconstel.Checked then
//          if Table_constellation[GCVS[i].Constellation].Checked then ch:=true else ch:=false;
       if GCVS[i]^.visible then
       begin
          Inc(cpt);
          if GCVS[i]^.Periode>0 then Str(GCVS[i]^.Periode:12:7,SPeriode) else SPeriode:='            ';
          Svar:=GCVS[i]^.Designation+'                  ';
          SVar:=Copy(SVar,1,5)+'  '+Table_Constellation[GCVS[i]^.Constellation].nom+
                '     '+GCVS[i]^.Type_variable+'                 ';
          if GCVS[i]^.Maximum>0 then Str(GCVS[i].Maximum:5:2,SMAxMag) else SMaxMag:=' --- ';
          if GCVS[i]^.Minimum>0 then Str(GCVS[i].Minimum:5:2,SMinMag) else SMinMag:=' --- ';
          SVar:=Copy(SVar,1,22)+'    '+SMaxMag+'   '+SMinMag+' '+SPeriode;
          if GCVS[i]^.Epoque>0 then Str(GCVS[i]^.Epoque:10:4,SEpoque) else
          begin
             if GCVS[i]^.YearNova>0 then
             begin
                Str(GCVS[i]^.YearNova:4:0,SEpoque); SEpoque:='('+SEPoque+')     ';
             end
             else SEpoque:='          ';
          end;
          SVar:=SVar+'  '+SEpoque+'  ';
          Str(GCVS[i]^.ADH:2:0,nb);
          bufAD:=nb+' ';
          Str(GCVS[i]^.ADM:2:0,nb);
          bufAD:=bufAD+nb+' ';
          Str(GCVS[i]^.ADS:4:1,nb);
          bufAD:=bufAD+nb+' ';

          Str(GCVS[i]^.DCD-0.00001:3:0,nb);
          bufDC:=nb+' ';
          Str(Abs(GCVS[i]^.DCM):2:0,nb);
          bufDC:=bufDC+nb+' ';
          Str(Abs(GCVS[i]^.DCS):2:0,nb);
          bufDC:=bufDC+nb;
          SVar:=SVar+bufAD+' '+bufDC+'   '+Copy(GCVS[i]^.TypeSpectral+'                 ',1,16);
          // Memo1.Lines.Append(svar);
          ListView1.Items.Add.Caption:=svar;
       end;
    end;
    Str(cpt:6,Svar);
    SVar:=SVar+' variables trouvées.';
    ListView1.Items.Add.Caption:=svar;
    ListView1.Items.EndUpdate;
    if cpt>0 then ButtonMesuresAFOEVListe.enabled:=true else ButtonMesuresAFOEVListe.enabled:=false;
//    Memo1.Lines.Append(svar);
//    Memo1.Lines.EndUpdate;
end;

procedure TForm1.ButtonVLPClick(Sender: TObject);
var
   v : integer;
begin
   CheckTypeVar.Checked:=True;
   For v:=0 to CheckListBox2.Count-1 do
   begin
      if CheckListBox2.Items.Strings[v]='M' then
      CheckListBox2.Checked[v]:=true;
      if CheckListBox2.Items.Strings[v]='RV' then
      CheckListBox2.Checked[v]:=true;
      if CheckListBox2.Items.Strings[v]='UGZ' then
      CheckListBox2.Checked[v]:=true;
      if CheckListBox2.Items.Strings[v]='SR' then
      CheckListBox2.Checked[v]:=true;
      if CheckListBox2.Items.Strings[v]='BY' then
      CheckListBox2.Checked[v]:=true;
      if CheckListBox2.Items.Strings[v]='ACYG' then
      CheckListBox2.Checked[v]:=true;
  end;
end;

procedure TForm1.ButtonMiraClick(Sender: TObject);
var
   v : integer;
begin
   CheckTypeVar.Checked:=True;
   For v:=0 to CheckListBox2.Count-1 do
   begin
      if CheckListBox2.Items.Strings[v]='M' then
      CheckListBox2.Checked[v]:=true;
  end;
end;

procedure TForm1.ButtonVCPClick(Sender: TObject);
var
   v : integer;
begin
   CheckTypeVar.Checked:=True;
   For v:=0 to CheckListBox2.Count-1 do
   begin
      if CheckListBox2.Items.Strings[v]='DSCT' then
      CheckListBox2.Checked[v]:=true;
      if CheckListBox2.Items.Strings[v]='ACVO' then
      CheckListBox2.Checked[v]:=true;
      if CheckListBox2.Items.Strings[v]='BCEP' then
      CheckListBox2.Checked[v]:=true;
      if CheckListBox2.Items.Strings[v]='EW' then
      CheckListBox2.Checked[v]:=true;
      if CheckListBox2.Items.Strings[v]='SXARI' then
      CheckListBox2.Checked[v]:=true;
      if CheckListBox2.Items.Strings[v]='SXPHE' then
      CheckListBox2.Checked[v]:=true;
      if CheckListBox2.Items.Strings[v]='UGSS' then
      CheckListBox2.Checked[v]:=true;
      if CheckListBox2.Items.Strings[v]='UG' then
      CheckListBox2.Checked[v]:=true;
      if CheckListBox2.Items.Strings[v]='ZZ' then
      CheckListBox2.Checked[v]:=true;
  end;
end;

procedure TForm1.ButtonRRLyraeClick(Sender: TObject);
var
   v : integer;
begin
   CheckTypeVar.Checked:=True;
   For v:=0 to CheckListBox2.Count-1 do
   begin
      if CheckListBox2.Items.Strings[v]='RR' then
      CheckListBox2.Checked[v]:=true;
      if CheckListBox2.Items.Strings[v]='RRAB' then
      CheckListBox2.Checked[v]:=true;
      if CheckListBox2.Items.Strings[v]='RRC' then
      CheckListBox2.Checked[v]:=true;
  end;
end;

procedure TForm1.Affiche_variable(Sender: TObject ; i : integer);
var
   s,sd,sm,ss : string;
   f_gcvs : file;
//   negatif : boolean;
begin
   With LabeledEdit8  do Text:=GCVS[i]^.Designation+' '+Table_Constellation[GCVS[i]^.Constellation].nom;
   With LabeledEdit9  do Text:=GCVS[i]^.Type_variable;
   With GCVS[i]^,LabeledEdit10 do Text:=TypeSpectral;
   With GCVS[i]^,LabeledEdit15 do
   begin
//      negatif:=((sign(DCD)+sign(DCM)+sign(DCS))<0);
      Str(DCD-0.00001:3:0,sd);
      Str(Abs(DCM):2:0,sm);
      Str(Abs(DCS):2:0,ss);
//      if negatif then s:='-' else s:='+';
      Text:={s+}sd+'°'+sm+''''+ss+'"'
{
          SVar:=SVar+'  '+SEpoque+'  ';
          Str(GCVS[i]^.ADH:2:0,nb);
          bufAD:=nb+' ';
          Str(GCVS[i]^.ADM:2:0,nb);
          bufAD:=bufAD+nb+' ';
          Str(GCVS[i]^.ADS:4:1,nb);
          bufAD:=bufAD+nb+' ';
}
   end;
   With GCVS[i]^,LabeledEdit14 do
   begin
      Str(ADH:2:0,sd);
      Str(ADM:2:0,sm);
      Str(ADS:2:0,ss);
      Text:=sd+'h'+sm+'m'+ss+'s'
   end;
   With GCVS[i]^,LabeledEdit12 do
   begin
      if Maximum=0 then s:='indéfini' else Str(Maximum:6:3,s); Text:=s;
   end;
   With GCVS[i]^,LabeledEdit13 do
   begin
      if Minimum=0 then s:='indéfini' else Str(Minimum:6:3,s); Text:=s;
   end;
   With GCVS[i]^,LabeledEdit11 do
   begin
      Str((2400000.0+Epoque):12:4,s); Text:=s;
   end;
   With GCVS[i]^,LabeledEdit16 do
   begin
      if Periode=0 then s:='indéfinie' else Str(Periode:10:6,s); Text:=Trim(s);
   end;
   With GCVS[i]^,LabeledEditMin2 do
   begin
      if Min2=0 then s:='indéfini' else Str(Min2:6:3,s); Text:=s;
   end;
//   AssignFile(f_gcvs,Rep_AAVSO+'\'+LabeledEdit8.Text+'.jpg');
     AssignFile(f_gcvs,Rep_AAVSO+'\'+LabeledEdit8.Text+'.png');
   {$I-}Reset(f_gcvs); {$I+}
   If IOResult=0 then
   begin
      Closefile(f_gcvs);
      Panel1.Visible:=False;
//      Image1.Picture.LoadFromFile(Rep_AAVSO+'\'+LabeledEdit8.Text+'.jpg');
      Image1.Picture.LoadFromFile(Rep_AAVSO+'\'+LabeledEdit8.Text+'.png');

      PopupMenu6.Items[0].Enabled:=True;
   end
   else
   begin
      AssignFile(f_gcvs,Rep_AAVSO+'\'+LabeledEdit8.Text+'.jpg');
//        AssignFile(f_gcvs,Rep_AAVSO+'\'+LabeledEdit8.Text+'.png');
      {$I-}Reset(f_gcvs); {$I+}
      If IOResult=0 then
      begin
         Closefile(f_gcvs);
         Panel1.Visible:=False;
         Image1.Picture.LoadFromFile(Rep_AAVSO+'\'+LabeledEdit8.Text+'.jpg');
//         Image1.Picture.LoadFromFile(Rep_AAVSO+'\'+LabeledEdit8.Text+'.png');

         PopupMenu6.Items[0].Enabled:=True;
      end
      else
      begin
         Panel1.Visible:=True;
         PopupMenu6.Items[0].Enabled:=False;
      end;
   end;

//      Image1.Picture.Bitmap.Canvas.FloodFill(ClientWidth div 2, ClientHeight div 2,clBlack,fsSurface);
end;

procedure TForm1.ButtonRechercheGCVSClick(Sender: TObject);
var
   i : integer;
   variable,v,c,b : string;
begin
   i:=0;
   b:=Trim(LabeledEdit7.Text);
   if length(b)>4 then
   begin
      V:=Copy(b,1,Length(b)-4);
      C:=Copy(b,Length(b)-2,3);
      Variable:=Trim(C)+Trim(V)+' ';
      i:=RechercheIndex(indexGCVS,GCVS_size,variable);
   end;

   if i=0 then
   begin
      With Application do MessageBox(PChar(mesg[8]),'',MB_OK);
      ButtonPublierMesures.Enabled:=false;
      ButtonRechAAVSO.Enabled:=false;
      ButtonEtalon.Enabled:=false;
      ButtonMesureAFOEV.Enabled:=false;
      ButtonAjoutVisible.Enabled:=false;
   end
   else
   begin
      GCVS_courant:=i;
      Affiche_variable(Sender,GCVS_courant);
      ButtonPublierMesures.Enabled:=true;
      ButtonRechAAVSO.Enabled:=true;
      ButtonEtalon.Enabled:=true;
      ButtonMesureAFOEV.Enabled:=true;
      ButtonAjoutVisible.Enabled:=true;
   end
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
   if GCVS_courant>1 then Dec(GCVS_courant);
   Affiche_variable(Sender,GCVS_courant);
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
   if GCVS_courant<GCVS_Size then Inc(GCVS_courant);
   Affiche_variable(Sender,GCVS_courant);
end;

procedure TForm1.ButtonFiltrerClick(Sender: TObject);
var
   i,cpt,no_type,code : integer;
   ch, chtype, crAlphaMin,crAlphaMax,crDeltaMax, crDeltaMin, crPerMin,crPerMax,crmagmax,crmagmin,
   Cr2ndMin,visibilite : boolean;
   CritereAlphaMin,CritereAlphaMax,CritereDeltaMin,CritereDeltaMax,CriterePerMax,CriterePerMin,
   CritereMagMax, CritereMagMin : real;
begin
    ButtonFiltrer.Enabled:=false;
    Val(LabeledEdit1.Text,CritereMagMax,code);
    Val(LabeledEdit2.Text,CritereMagMin,code);
    Val(LabeledEdit19.Text,CriterePerMax,code);
    Val(LabeledEdit20.Text,CriterePerMin,code);
    Val(LabeledEdit5.Text,CritereAlphaMax,code);
    Val(LabeledEdit6.Text,CritereAlphaMin,code);
    Val(LabeledEdit4.Text,CritereDeltaMax,code);
    Val(LabeledEdit3.Text,CritereDeltaMin,code);
    cpt:=0;
    for i:=1 to GCVS_Size do
    begin
       {if CheckBoxRefiltrer.Checked then ch:=GCVS[i]^.visible else} ch:=True;
       chtype:=true;
//       if checkconstel.Checked then
       if Table_constellation[GCVS[i]^.Constellation].Checked then ch:=true
          else ch:=false;
//       if checkTypeVar.Checked then
       begin
          chtype:=false;
          for no_type:=0 to CheckListBox2.Count-1 do
             if CheckListBox2.Checked[no_type] then
                if Pos(CheckListBox2.Items.Strings[no_type],GCVS[i]^.Type_variable)>0 then chtype:=true;
       end;
       Cr2ndMin:=not CheckMag2ndMin.Checked or (GCVS[i]^.Min2>0);
       CrMagMax:=not CheckMagMax.Checked or (GCVS[i]^.Maximum>CritereMagMax);
       CrMagMin:=not CheckMagMin.Checked or (GCVS[i]^.Minimum<CritereMagMin);
       CrPerMax:=not CheckPerMax.Checked or (GCVS[i]^.Periode<CriterePerMax);
       CrPerMin:=not CheckPerMin.Checked or (GCVS[i]^.Periode>CriterePerMin);
       CrAlphaMax:=not CheckADMax.Checked or (GCVS[i]^.Alpha<CritereAlphaMax);
       CrAlphaMin:=not CheckADMin.Checked or (GCVS[i]^.Alpha>CritereAlphaMin);
       CrDeltaMax:=not CheckDecMax.Checked or (GCVS[i]^.Delta<CritereDeltaMax);
       CrDeltaMin:=not CheckDecMin.Checked or (GCVS[i]^.Delta>CritereDeltaMin);
       visibilite:=(Cr2ndMin and CrDeltaMin and CrDeltaMax and CrAlphaMin and CrAlphaMax and CrPerMin and
                         CrPErMax and CrMagMax and CrMagMin and ch and chtype);
       if (not CheckBoxRefiltrer.Checked) and (not CheckBoxFiltreLExistant.Checked) then GCVS[i]^.visible:=visibilite else
       begin
          if CheckBoxRefiltrer.Checked then GCVS[i]^.visible:=GCVS[i]^.visible or visibilite;
          if CheckBoxFiltreLExistant.Checked then GCVS[i]^.visible:=GCVS[i]^.visible and visibilite;

       end;

       if GCVS[i]^.visible then inc(cpt);
    end;
    if cpt>0 then
    begin
       MenuItem3.Enabled:=true;
       ButtonMesuresAFOEVListe.Enabled:=true;
    end else
    begin
       ButtonMesuresAFOEVListe.Enabled:=false;
       MenuItem3.Enabled:=false;
    end;
    ButtonFiltrer.Enabled:=true;
end;

procedure TForm1.BitBtnExportVariableClick(Sender: TObject);
var
   f_exp : textfile;
   i,reponse : longint;
   svar,bufAD,bufDC : string;
begin
   case Application.MessageBox('Export PRISM ?','',MB_YESNOCANCEL) of
   IDYes :
       if SaveDialog1.Execute then
       begin
          reponse:=IDYES;
          AssignFile(f_exp,SaveDialog1.FileName);
          {$I-}Reset(f_exp); {$I+}
          If IOResult=0 then
          begin
             reponse:=Application.MessageBox(PChar(mesg[9]),'',MB_YESNOCANCEL);
             closefile(f_exp);
          end;
          AssignFile(f_exp,SaveDialog1.FileName);
          case reponse of
          IDYes : Rewrite(f_exp);
          IDNo  : Append(f_exp);
          end;
          if reponse<>IDCANCEL then
          begin
             For i:=1 to GCVS_Size do
                With GCVS[i]^ do
                   if visible then
                   begin
                      Str(ADH:2:0,svar);
                      bufAD:=svar+'h';
                      Str(ADM:2:0,svar);
                      bufAD:=bufAD+svar+'m';
                      Str(ADS:6:3,svar);
                      bufAD:=bufAD+svar+'s';

                      Str(abs(DCD):2:0,svar);
                      bufDC:=svar+'°';  if Delta>0 then bufDC:='+'+bufDC else bufDC:='-'+bufDC;
                      Str(abs(DCM):2:0,svar);
                      bufDC:=bufDC+svar+'''';
                      Str(abs(DCS):6:2,svar);
                      bufDC:=bufDC+svar+'''''';

                      bufAD:= StringReplace(bufAD,' ','0',[rfReplaceAll]);
                      bufDC:= StringReplace(bufDC,' ','0',[rfReplaceAll]);

                      Writeln(f_exp,'"',designation,' ',Table_Constellation[constellation].nom,
                                    '"  ',bufAD,'  ',bufDC,'  ',Maximum:4:1,'  FALSE  ','"',Type_variable,'"');
                   end;
             Closefile(f_exp);
          end;
       end;
    IDNo :
       if SaveDialog1.Execute then      // Export neutre
       begin
          reponse:=IDYES;
          AssignFile(f_exp,SaveDialog1.FileName);
          {$I-}Reset(f_exp); {$I+}
          If IOResult=0 then
          begin
             reponse:=Application.MessageBox(Pchar(mesg[9]),'',MB_YESNOCANCEL);
             closefile(f_exp);
          end;
          AssignFile(f_exp,SaveDialog1.FileName);
          case reponse of
          IDYes : Begin Rewrite(f_exp); Writeln(f_exp,mesg[10]); end;
          IDNo  : Append(f_exp);
          end;
          if reponse<>IDCANCEL then
          begin
             For i:=1 to GCVS_Size do
                With GCVS[i]^ do
                   if visible then
                   begin
                      Str(ADH:2:0,svar);
                      bufAD:=svar+'h';
                      Str(ADM:2:0,svar);
                      bufAD:=bufAD+svar+'m';
                      Str(ADS:6:3,svar);
                      bufAD:=bufAD+svar+'s';

                      Str(DCD:2:0,svar);
                      bufDC:=svar+'°';
                      Str(DCM:2:0,svar);
                      bufDC:=bufDC+svar+'''';
                      Str(DCS:6:3,svar);
                      bufDC:=bufDC+svar+'''''';

                      bufAD:= StringReplace(bufAD,' ','0',[rfReplaceAll]);
                      bufDC:= StringReplace(bufDC,' ','0',[rfReplaceAll]);

                      Writeln(f_exp,'"',designation,' ',Table_Constellation[constellation].nom,
                                    '"  ',bufAD,'  ',bufDC,'  ',Maximum:4:1,' ',minimum:4:1,' "',Type_Variable,'" ',periode:5:3,' ',Epoque:12:5);
                   end;
             Closefile(f_exp);
          end;
       end;

    end;
end;

procedure TForm1.TabSheet3ContextPopup(Sender: TObject; MousePos: TPoint;
  var Handled: Boolean);
begin

end;

procedure TForm1.Effacer4Click(Sender: TObject);
var
   i,j : integer;
   trouve : boolean;
   s : string;
begin
   i:=ListView3.Selected.Index;

   trouve:=false;
   {bug à corriger : quand on sélectionne la ligne des titres on provoque un arrêt }
   if i>=0 then
   begin
       s:=Trim(Copy(ListView3.Items[i].Caption,1,5))+' '+Trim(Copy(ListView3.Items[i].Caption,8,3));

       j:=1;
       repeat
           if s=(GCVS[j]^.Designation+' '+Table_Constellation[GCVS[j]^.Constellation].nom) then
              trouve:=true
           else
              inc(j);
        until trouve or (j>GCVS_size);
        if trouve then
        begin
           With GCVS[j]^ do visible:=false;
           Form1.TabSheet6Show(Sender);
        end;

    end;
end;
procedure TForm1.Effacer1Click(Sender: TObject);
var
   i,j : integer;
   trouve : boolean;
   s : string;
begin
//   Label3.Caption:= Memo1.SelText;
//   ListView1.DeleteSelected;
   i:=ListView1.Selected.Index;

   trouve:=false;
   {bug à corriger : quand on sélectionne la ligne des titres on provoque un arrêt }
   if i>=0 then
   begin
      s:=Trim(Copy(ListView1.Items[i].Caption,1,5))+' '+Trim(Copy(ListView1.Items[i].Caption,8,3));
//      Label3.Caption:='"'+s+'"';
             j:=1;
      repeat
         if s=(GCVS[j]^.Designation+' '+Table_Constellation[GCVS[j]^.Constellation].nom) then
            trouve:=true
         else
            inc(j);
      until trouve or (j>GCVS_size);
      if trouve then
      begin
         With GCVS[j]^ do visible:=false;
    //      Str(i:3,s);
         Form1.TabSheet2Show(Sender);
      end;

   end;
end;
procedure TForm1.Voirdtails1Click(Sender: TObject);
var
   i : integer;
begin
   i:=CheckListBox2.ItemIndex;
   Label3.Caption:=CheckListBox2.Items[i]; // marche. Reste à faire l'accès à la doc.
end;

procedure TForm1.Configurer1Click(Sender: TObject);
begin
   Form10.Show;
end;

{$IFDEF LINUX}
function TForm1.DownloadFileHttp(const fileURL,FileName: string):Boolean ;
// Download file; retry if necessary.
// Could use Synapse HttpGetBinary, but that doesn't deal
// with result codes (i.e. it happily downloads a 404 error document)
const
  MaxRetries = 3;
var
  HTTPGetResult: Boolean;
  HTTPSender: THTTPSend;
  RetryAttempt: Integer;
begin
  Result := False;
  RetryAttempt := 1;
  HTTPSender := THTTPSend.Create;
  try
    try
      // Try to get the file
      HTTPGetResult := HTTPSender.HTTPMethod('GET', fileURL);
      while (HTTPGetResult = False) and (RetryAttempt < MaxRetries) do
      begin
        Sleep(500 * RetryAttempt);
        HTTPGetResult := HTTPSender.HTTPMethod('GET', fileURL);
        RetryAttempt := RetryAttempt + 1;
      end;
      // If we have an answer from the server, check if the file
      // was sent to us.
      case HTTPSender.Resultcode of
        100..299:
          begin
            HTTPSender.Document.SaveToFile(FileName);
            Result := True;
          end; //informational, success
        300..399: Result := False; // redirection. Not implemented, but could be.
        400..499: Result := False; // client error; 404 not found etc
        500..599: Result := False; // internal server error
        else Result := False; // unknown code
      end;
    except
      // We don't care for the reason for this error; the download failed.
      Result := False;
    end;
  finally
    HTTPSender.Free;
  end;
end;
{$ENDIF}
{$IFDEF MSWINDOWS}
function TForm1.DownloadFileHttp(const fileURL,FileName: string):Boolean ;
const BufferSize = 1024;
var hSession, hURL: HInternet;
    Buffer: array[1..1024] of Byte;
    BufferLen: DWORD;
//    f: File;
    sAppName: string;
    FS:TFileStream;
begin
     Result   := False;
     sAppName := ExtractFileName(Application.ExeName);

     hSession := InternetOpen(PChar(sAppName),INTERNET_OPEN_TYPE_PRECONFIG,
     'xxx_Login_Proxy_Nom Utilisateur_xxx','xxx_Login_Proxy_Mot_de_Passe_xxx',0);

     if FileExists{UTF8}(FileName) { *Converted from FileExists*  } then DeleteFile{UTF8}(FileName); { *Converted from DeleteFile*  }
     FS:=TFileStream.Create(FileName,fmCreate);
     try
        hURL := InternetOpenURL(hSession, PChar(fileURL), nil,0,0,0);
        try
           repeat
             InternetReadFile(hURL, @Buffer, BufferSize, BufferLen);
             FS.WriteBuffer(Buffer, BufferLen);
//             Label1.Caption:=IntToStr(fs.Size);
           until BufferLen = 0;
           Result:=True;
        finally
          InternetCloseHandle(hURL)
        end
     finally
         InternetCloseHandle(hSession);
         FS.Free;
     end;
     DownloadFileHttp:=Result;
end;
{$ENDIF}
procedure TForm1.ButtonRecupSNHttpClick(Sender: TObject);
var
   FileName,URL,aaaa_s,mm_s,jj_s,date_s,date_limite,classif_s : string;
   s_sn,buffer : Widestring;
   f_sn : Textfile;
   magnitudeSNLimite,CritereAlphaMax,CritereAlphaMin,
   CritereDeltaMax,CritereDeltaMin,sn_alpha,sn_delta,VOffset,OEW,ONS : real; // SeparationLimite
   i,k,c_sn,jj,mm,aaaa,code,nb_mot,ligne : integer;
   file_ok,sn_ok : boolean;
   reponse : longint;
   mot : t_phrase;
   sep,enc : char;
begin
   if LabeledEdit5.Text='' then CritereAlphaMax:=24  else Val(LabeledEdit5.Text,CritereAlphaMax,code);
   if LabeledEdit6.Text='' then CritereAlphaMin:=0   else Val(LabeledEdit6.Text,CritereAlphaMin,code);
   if LabeledEdit4.Text='' then CritereDeltaMax:=90  else Val(LabeledEdit4.Text,CritereDeltaMax,code);
   if LabeledEdit3.Text='' then CritereDeltaMin:=-90 else Val(LabeledEdit3.Text,CritereDeltaMin,code);
   date_s:='';
   if CheckBoxDateSN.Checked then
   begin
      jj:=DayOf(DateTimePicker1.Date);
      mm:=MonthOf(DateTimePicker1.Date);
      aaaa:=YearOf(DateTimePicker1.Date);
      Str(aaaa:4,aaaa_s);
      Str(mm,mm_s); if mm<10 then mm_s:='0'+mm_s;
      Str(jj,jj_s); if jj<10 then jj_s:='0'+jj_s;
      date_s:=aaaa_s+'-'+mm_s+'-'+jj_s;
      date_limite:='&date_start[date]='+date_s;

      jj:=DayOf(ToDay);
      mm:=MonthOf(ToDay);
      aaaa:=YearOf(ToDay);
      Str(aaaa:4,aaaa_s);
      Str(mm,mm_s); if mm<10 then mm_s:='0'+mm_s;
      Str(jj,jj_s); if jj<10 then jj_s:='0'+jj_s;
      date_limite:=date_limite+'&date_end[date]='+aaaa_s+'-'+mm_s+'-'+jj_s;

   end;      {pour le champ date_start[date]=AAAA-MM-JJ
                   le champ date_end[date]=Date du jour}
   FileName:='tns_search.csv';
   classif_s:='';
   sep:=',';
   enc:='"';

   if CheckBoxClassifiedSN.Checked then
   begin
      classif_s:='&classified_sne=1'
   end;
   URL:='https://wis-tns.weizmann.ac.il/search?&isTNS_AT=yes&format=csv'+date_limite+classif_s;   // Requête pour le Weizmann intitute

   AssignFile(f_sn,FileName);
   {$I-}Reset(f_sn); {$I+}
   file_ok:=(IOResult=0);
   if file_ok then closefile(f_sn);

   ButtonRecupSNHttp.Enabled:=false;

   if file_ok then
   begin
      reponse:=Application.MessageBox(PChar(mesg[11]),'',MB_YESNOCANCEL);
      case reponse of
      IDNo : file_ok:=DownloadFileHttp(URL,FileName);
      IDYes : file_ok:=true;
      IDCancel : file_ok:=false;
      end;
   end
   else file_ok:=DownloadFileHttp(URL,FileName);
   if file_ok then
   begin
     Val(Trim(LabeledEditMagSNLimite.Text),magnitudeSNLimite,code);

// On charge le fichier CSV dans le tableau pour traitement :
     StringGridpourCSV.LoadFromCSVFile(Filename,',',true,0,true);
     StringGridpourCSV.DeleteCol(0);
     StringGridpourCSV.DeleteCol(6);
     StringGridpourCSV.DeleteCol(7);
     StringGridpourCSV.DeleteCol(7);
     StringGridpourCSV.DeleteCol(7);
     StringGridpourCSV.DeleteCol(7);
     StringGridpourCSV.DeleteCol(7);
     StringGridpourCSV.DeleteCol(7);
     StringGridpourCSV.DeleteCol(7);
     StringGridpourCSV.DeleteCol(7);
     StringGridpourCSV.DeleteCol(7);

     StringGridpourCSV.DeleteCol(8);
     StringGridpourCSV.DeleteCol(9);
//     StringGridpourCSV.DeleteCol(8);



     for c_sn:=1 to SN_Size do Dispose(sn[c_sn]);
     c_sn:=0;
     ligne:=0;


     ListView2.Items.Clear;
     ListView2.Items.BeginUpdate;

     repeat

        inc(c_sn);
        inc(ligne);
        New(sn[c_sn]);

        for k:=1 to 10 do   // On prend les 10 premiers mots de chaque ligne du fichier CSV.
           Mot[k]:=StringGridpourCSV.Cells[k-1,ligne];


//        code:=Application.MessageBox(PChar('So Far so good'),'',MB_YESNOCANCEL);

        sn[c_sn]^.nom:=Mot[1];

        sn[c_sn]^.galaxie:=Mot[6];

        sn[c_sn]^.date:=Copy(Mot[9],1,10);
//   Filtrage date effectué par la requête, les lignes suivantes ne sont plus nécessaires
//               if CheckBoxDateSN.Checked then
//                 if sn[c_sn]^.date>date_s then sn_ok:=true else sn_ok:=false
//              else
        sn_ok:=true;
        VOffset:=0;
// Extraction de la séparation de la SN au noyau galactique :
{
        OEW:=0; ONS:=0;
        Val(Trim(Copy(s_sn,46,3)),OEW,code);
        Val(Trim(Copy(s_sn,51,3)),ONS,code);
        VOffset:=Sqrt(OEW*OEW+ONS*ONS);
        if VOffset>0 then
           sn_ok:=sn_ok and (VOffset>SeparationLimite);
}
        if sn_ok then
        begin
           if VOffset>0 then
              Str(VOffset:3:0,sn[c_sn]^.offsets)
           else sn[c_sn]^.offsets:='  ?';

           sn[c_sn]^.mag:=Mot[8];
           Val(sn[c_sn]^.mag,sn[c_sn]^.magnitude,code);
           Str(sn[c_sn]^.magnitude:5:2,sn[c_sn]^.mag);
           Val(Trim(sn[c_sn]^.mag),sn[c_sn]^.magnitude,code);
           StringGridpourCSV.Cells[7,ligne]:=sn[c_sn]^.mag;

           if CheckBoxMagSN.Checked then
              if sn[c_sn]^.magnitude>magnitudeSNLimite then
                 sn_ok:=false;

           if sn_ok then
           begin

              sn[c_sn]^.alpha:=Mot[2];
              sn[c_sn]^.delta:=Mot[3];
              if CheckBoxAlphaSN.Checked then
              begin
                 Val(copy(sn[c_sn]^.alpha,1,2),sn_alpha,code);
                 sn_ok:=(sn_alpha<CritereAlphaMax) and (sn_alpha>=CritereAlphaMin)
              end;
              if CheckBoxDeltaSN.Checked then
              begin
                 Val(copy(sn[c_sn]^.delta,1,3),sn_delta,code);
//
                 sn_ok:=sn_ok and (sn_delta<CritereDeltaMax) and (sn_delta>=CritereDeltaMin)
              end;

              if sn_ok then
              begin

                  sn[c_sn]^.sn_type:=Mot[4];
                  sn[c_sn]^.decouvreur:=Mot[7];
                  With sn[c_sn]^ do
                     s_sn:=nom+Copy('  ',1,6-Length(nom))+'  '
                           +Copy(galaxie,1,20)+Copy('                    ',1,20-Length(galaxie))
                           +' '+date+'  '+alpha+'  '+delta+'  '+mag+'  '+Copy(sn_type,1,16)
                           +Copy('                    ',1,14-Length(sn_type))+decouvreur;
                  ListView2.Items.Add.Caption:=s_sn;
              end;
           end;
        end;

        if not sn_ok then
        begin
           Dispose(sn[c_sn]);
           Dec(c_sn);
        end;

     until ligne=StringGridpourCSV.RowCount-1;
     ListView2.Items.EndUpdate;

     SN_Size:=c_sn

   end;

   ButtonRecupSNHttp.Enabled:=true;
end;

procedure TForm1.Sauverconfig;
var
   f_const : TextFile;
begin
   AssignFile(f_const,RepertoireInitial+'ginseng.ini');
   {$I-}Rewrite(f_const); {$I+}
   If IOResult=0 then
   begin
      Writeln(f_const,'# Fichier de configuration de g''ngseng');
      Writeln(f_const,'[Reglages]');
      Writeln(f_const,'Rep.AAVSO=',Rep_AAVSO);
      Writeln(f_const,'Fic.Constel=',Fic_Constel);
      Writeln(f_const,'Fic.GCVS=',Fic_GCVS);
      Writeln(f_const,'URL.SN=',URL_sn);
      Writeln(f_const,'URL.GCVS=',URL_GCVS);
      Writeln(f_const,'Langage=',langage);
      If Form10.CheckboxForceGEOS.Checked then
         Writeln(f_const,'ForceGEOS=1')
      else
         Writeln(f_const,'ForceGEOS=0');
      If Form10.CheckboxKeepGEOSData.Checked then
         Writeln(f_const,'KeepGEOS=1')
      else
         Writeln(f_const,'KeepGEOS=0');
      Writeln(f_const,'URL.Novae=',URL_Novae);
      Writeln(f_const,'Rep.ReqAFOEV=',Rep_ReqAFOEV);
      Writeln(f_const,'Rep.ReqAAVSO=',Rep_ReqAAVSO);
      Writeln(f_const,'TabSheet.Init=',PageControl1.TabIndex);
      if CheckBoxNord.checked then Writeln(f_const,'Variable.Carte.NordEnHaut=1') else Writeln(f_const,'Variable.Carte.NordEnHaut=0');
      Writeln(f_const,'Variable.Carte.Champ=',EditTailleChamp.Text);
      Writeln(f_const,'[RRLyrae]');
      Writeln(f_const,'RRLyrae.DelaiMax=',SpinEditMaxiAvant.Value);

      Writeln(f_const,'[Supernovae]');
      Writeln(f_const,'Supernovae.separation=',LabeledEditSeparation.Text);
      If CheckBoxAlphaSN.Checked then Writeln(f_const,'Supernovae.CheckAlpha=1') else Writeln(f_const,'Supernovae.CheckAlpha=0');
      If CheckBoxDeltaSN.Checked then Writeln(f_const,'Supernovae.CheckDelta=1') else Writeln(f_const,'Supernovae.CheckDelta=0');
      If CheckBoxMagSN.Checked then Writeln(f_const,'Supernovae.CheckMaglimite=1') else Writeln(f_const,'Supernovae.CheckMaglimite=0');
      Writeln(f_const,'Supernovae.Maglimite=',LabeledEditMagSNLimite.Text);

      Writeln(f_const,'[Novae]');
      if CheckBoxMagLimiteNovae.Checked then Writeln(f_const,'Novae.CheckMaglimite=1') else Writeln(f_const,'Novae.CheckMaglimite=0');
      Writeln(f_const,'Novae.Maglimite=',LabeledEditMagNovaeLimite.Text);
      
      Writeln(f_const,'[Rapport]');
      Writeln(f_const,'Rapport.AFOEV.Fichier=',Fic_RapportAFOEV);
      Writeln(f_const,'Rapport.Obs.AFOEV=',Rapport_Obs_AFOEV);
      Writeln(f_const,'Rapport.Obs.VSNET=',Rapport_Obs_VSNet);
      if Acknowledgment_Agree then
      begin
         Writeln(f_const,'[Acknowledgment]');
         Writeln(f_const,'Acknowledgment.Agree=OK');
      end;
      closefile(f_const)

   end else Application.MessageBox(mesg[12],'',MB_OK)
end;

procedure TForm1.Sauverconfig1Click(Sender: TObject);
begin
   SauverConfig;
end;

procedure TForm1.ButtonExportSN_PrismClick(Sender: TObject);
var
   i : integer;
   reponse : longint;
   f_exp : TextFile;
   AD,DC : string;
begin

   if SaveDialog1.Execute then
   begin
      reponse:=IDYES;
      AssignFile(f_exp,SaveDialog1.FileName);
      {$I-}Reset(f_exp); {$I+}
      If IOResult=0 then
      begin
         reponse:=Application.MessageBox(PChar(mesg[9]),'',MB_YESNOCANCEL);
         closefile(f_exp);
      end;
      AssignFile(f_exp,SaveDialog1.FileName);
      case reponse of
      IDYes : Rewrite(f_exp);
      IDNo  : Append(f_exp);
      end;
      if reponse<>IDCANCEL then
      begin
         For i:=1 to SN_Size do
            With SN[i]^ do
               begin
             {     Str(ADH:2:0,svar);
                  bufAD:=svar+'h';
                  Str(ADM:2:0,svar);
                  bufAD:=bufAD+svar+'m';
                  Str(ADS:6:3,svar);
                  bufAD:=bufAD+svar+'s';

                  Str(DCD:2:0,svar);
                  bufDC:=svar+'°';
                  Str(DCM:2:0,svar);
                  bufDC:=bufDC+svar+'''';
                  Str(DCS:6:3,svar);
                  bufDC:=bufDC+svar+'''''';

                  bufAD:= StringReplace(bufAD,' ','0',[rfReplaceAll]);
                  bufDC:= StringReplace(bufDC,' ','0',[rfReplaceAll]);
             }
                  with SN[i]^ do
                  begin
                     AD:=Copy(Alpha,1,2)+'h'+Copy(Alpha,4,2)+'m'+Copy(Alpha,7,4)+'00s';
                     DC:=Copy(Delta,1,3)+Char(248)+Copy(Delta,5,2)+''''+Copy(Delta,8,4)+'00'+'''''';
                     Writeln(f_exp,'"',nom,
                                '"  ',AD,'  ',DC,'  ',magnitude:4:1,'  FALSE  ','"Supernova('+galaxie+')"');
                  end;
               end;
         Closefile(f_exp);
      end;
   end;

end;

procedure TForm1.ButtonRechAAVSOClick(Sender: TObject);
var
   buffer,FileName_image,URL_image,filename_json,URL_requete,nomvar,north,east : string;
   f_json,f_gcvs : TextFile;
   vJSONData : TJSONData;
   valeur,maglim : real;
   code          : integer;
begin
   ButtonRechAAVSO.Enabled:=False;



   URL_requete:='https://app.aavso.org/vsp/api/chart/?format=json';
   Val(EditTailleChamp.Caption,valeur,code);
   if code=0 then URL_requete:=URL_requete+'&fov='+Trim(EditTailleChamp.Text);
   Val(EditMaglimit.Text,maglim,code);
   if code=0 then URL_requete:=URL_requete+'&maglimit='+Trim(EditMaglimit.Text);
   if CheckboxNord.State=cbChecked then north:='up' else north:='down';
   if CheckboxEst.State=cbChecked then east:='left' else east:='right';


   FileName_json :='variable.json';
   if LabeledEdit8.Text<>'' then
      with GCVS[GCVS_courant]^ do
      begin
         URL_requete:=URL_requete+'&star='+designation+'+'
                 +Table_Constellation[Constellation].nom;
     {    NFichier:=rep_AAVSO+'\'+designation+' '
                 +Table_Constellation[Constellation].nom+'.json';
         OFichier:=rep_AAVSO+'\'+designation+' '
                 +Table_Constellation[Constellation].nom+'_etalon_json.txt';   }

         nomvar:=designation+' '+Table_Constellation[Constellation].nom;
         FileName_image:=rep_AAVSO+'\'+nomvar+'.png';
      end else
      begin
         {             https://app.aavso.org/vsp/api/chart/?ra=21%3A42%3A42.94&dec=43%3A35%3A09.9&fov=60&maglimit=14.5}
         URL_requete:='https://app.aavso.org/vsp/api/chart/?ra='+LabeledEdit14.Text+'&dec='+LabeledEdit15.Text+
                      '&fov='+Trim(EditTailleChamp.Text)+'&maglimit='+Trim(EditMaglimit.Text)+'&east='+east+'&north='+north+{&other=gcvs&lines=on'}
                      '&format=json';

         FileName_image:=rep_AAVSO+'\'+'zone.png';
      end;
   ButtonRecupSNHttp.Enabled:=false;
   if DownloadFileHttp(URL_requete,FileName_json) then // on envoie une première requête
   begin                                       // dont le résultat est analysé ici :

      AssignFile(f_json,FileName_json);
      {$I-}Reset(f_json); {$I+}
      If IOResult=0 then
      begin

         readln(f_json,buffer);

         vJSONData := GetJSON(buffer);

         if Pos('errors',buffer)=0 then
         begin
            URL_image:=vJSONData.FindPath('image_uri').AsString;



            if DownloadFileHttp(URL_image,FileName_image) then
            begin
               if LabeledEdit8.Text<>'' then
                  Affiche_variable(Sender,GCVS_courant)
               else    { On affiche l'image de la zone demandée }
               begin

                  AssignFile(f_gcvs,FileName_image);
                  {$I-}Reset(f_gcvs); {$I+}
                  If IOResult=0 then
                  begin
                     Closefile(f_gcvs);
                     Panel1.Visible:=False;

                     Image1.Picture.LoadFromFile(FileName_image);
                     PopupMenu6.Items[0].Enabled:=True;
                  end
                  else
                  begin
                     Panel1.Visible:=True;
                     PopupMenu6.Items[0].Enabled:=False;
                  end;
               end;
            end;
         end;

         CloseFile(f_json);
      end;
   end;


   ButtonRechAAVSO.Enabled:=True;

end;

procedure TForm1.PopupMenu3Popup(Sender: TObject);
var
i : integer;
begin
   i:=ListView2.ItemIndex;
   if i>=0 then
    begin
//      sn_g:= copy(sn[i+1]^.galaxie,1,Pos(' ',sn[i+1]^.galaxie));
//      if (sn_g='NGC ') or (sn_g='UGC ') or (sn_g='IC ') then VoirChamp1.Enabled:=true
//      else VoirChamp1.Enabled:=False;
      if trim(sn[i+1]^.galaxie)<>'Anon.' then VoirChamp1.Enabled:=true
      else VoirChamp1.Enabled:=False;
   end;
end;

procedure TForm1.Voirchamp1Click(Sender: TObject);
var
   designation,URL,Filename_html,buffer,g,annee : string;
   message : PChar; // PWideChar en Delphi;
   c_sn,i : integer;
   f_html : TextFile;
   trouve : boolean;
begin
   c_sn:=ListView2.ItemIndex+1;
   g:=trim(sn[c_sn]^.galaxie);

   URL:='http://www.rochesterastronomy.org/snimages/reference/';
   FileName_html:='index_image_Rochester.html';
   if DownloadFileHttp(URL,FileName_html) then
   begin

// à compléter avec l'affichage de l'image
      AssignFile(f_html,FileName_html);
      {$I-}Reset(f_html); {$I+}
      If IOResult=0 then
      begin  // on lit le fichier des références des images de galaxies
         repeat
            readln(f_html,buffer);
            trouve:=(Pos(g,buffer)<>0);
         until trouve or eof(f_html); // jusqu'à trouver la bonne référence
         if trouve then
         begin
            i:=Pos('"',buffer);
            designation:=Copy(buffer,i+1,99);
            i:=Pos('"',designation);
            designation:=Copy(designation,1,i-1);
            URL:=URL+designation;
//            while Pos('../',designation)>0 do
//               Delete(designation,Pos('../',designation),3);

// à terminer pour gérer le chemin correct pour la sauvegarde de l'image
            Filename_html:=g+'.jpg';
            ChangeFileExt(Filename_html,ExtractFileExt(designation));
//            message:=PAnsiChar('référence de l''image '+designation+' trouvée.');
//            Application.MessageBox(message,'');
            if DownloadFileHttp(URL,FileName_html) then
            begin

//               message:=PAnsiChar('image '+URL+' trouvée');
//               Application.MessageBox(message,'');
               Form6.Image1.Picture.LoadFromFile(Filename_html);
               Form6.Caption:=g;
               Form6.Show
            end
         end
         else
         begin
            message:=PChar(Concat(String(mesg[13]),g,String(mesg[14])));
            Application.MessageBox(message,'',MB_OK);

         end
      end;
      CloseFile(f_html);
   end;
end;

procedure TForm1.Voirchamp2Click(Sender: TObject);
var
   g,RA,DC,buffer,FileName_image,filename_html,URL,nomvar,params : string;
   f_html : TextFile;
   c_sn,k      : integer;
//   result : THandle;
   zNCONVERT,zPARAMS : array[0..200] of Char;
begin
//
//  Procédure de recherche de la carte de champ d'une galaxie à partir de ses coordonnées
//  On utilise une requête sur le serveur de l'AAVSO du type :
//  http://mira.aavso.org/cgi-bin/vsp.pl?action=render&ra=05:52&dec=+15:58&charttitle=&chartcomment=&aavsoscale=Choose&fov=20&resolution=100&maglimit=16&north=down&east=left&othervars=gcvs&chartid=&Submit=Plot+Chart
//

   c_sn:=ListView2.ItemIndex+1;
   g:=trim(sn[c_sn]^.galaxie);
//

   PopupMenu3.Items[0].Checked:=True;
   PopupMenu3.Items[0].Enabled:=False;
   with sn[c_sn]^ do
   begin
      RA:=Trim(Alpha);  while Pos(' ',RA)>0 do RA[Pos(' ',RA)]:=':';
      DC:=Trim(Delta);  while Pos(' ',DC)>0 do DC[Pos(' ',DC)]:=':';

      URL:='http://www.aavso.org/cgi-bin/vsp.pl?action=render+'
           +'&ra='+RA+'&dec='+DC+'&charttitle=&chartcomment='+g+'&aavsoscale=Choose&fov='+Edittaillechamp.Text
           +'&resolution=100&maglimit=16&';
      if CheckBoxNord.Checked then
         URL:=URL+'south=down'
      else
         URL:=URL+'north=down';
      if CheckBoxEst.Checked then
         URL:=URL+'&east=left'
      else
         URL:=URL+'&east=';

      URL:=URL+'&othervars=gcvs&chartid=&Submit=Plot+Chart';


      FileName_html :='variable.html';

//      FileName_image:=Trim(nom)+'.png';
      FileName_image:=rep_AAVSO+'\'+Trim(sn[c_sn]^.nom)+'.png'
   end;
   ButtonRecupSNHttp.Enabled:=false;

   if DownloadFileHttp(URL,FileName_html) then // on envoie une première requête au site AAVSO
   begin                                       // dont le résultat est analysé ici :
      k:=0;
      AssignFile(f_html,FileName_html);
      {$I-}Reset(f_html); {$I+}
      If IOResult=0 then
      begin
         repeat
            readln(f_html,buffer);
            k:=Pos('<img src="',buffer);
         until Eof(f_html) or (k<>0);
         if (k<>0) then
         begin    // A revoir car on ne telecharge pas le bon fichier :

            buffer:=MidStr(buffer,k,length(buffer)-k);
//            buffer:=MidStr(buffer,Pos('"http',buffer)+1,999);
            buffer:=MidStr(buffer,Pos('"/',buffer)+1,Pos('" ',buffer));
            buffer:=MidStr(buffer,1,Pos('" ',buffer)-1);
              URL:='http://www.aavso.org'+buffer;
//            Panel1.Caption:=buffer;
            if DownloadFileHttp(URL,FileName_image) then
//               Panel1.Caption:=buffer;
//nconvert -out jpeg -o "T Cam.jpg"  "T Cam.png"
//            Params:='-out jpeg -o "'+rep_AAVSO+'\'+Trim(sn[c_sn]^.nom)+'.jpg" "'+FileName_image+'"';
//            if ShellExecute(Application.MainForm.Handle,nil,
//                         StrPCopy(zNCONVERT,'nconvert.exe'),
//                         StrPCopy(zPARAMS,params),'',SW_SHOW)<=32 then
//                         ShowMessage(SysErrorMessage(GetLastError)) else
            begin

               Sleep(2000);
               Form5.Image1.Picture.LoadFromFile(rep_AAVSO+'\'+Trim(sn[c_sn]^.nom)+'.png');
               Form5.Caption:=Trim(sn[c_sn]^.nom);
               Form5.Show
            end;
         end;
         CloseFile(f_html);
      end;
   end;
   PopupMenu3.Items[0].Checked:=False;
   PopupMenu3.Items[0].Enabled:=True;
end;


procedure TForm1.TabSheet6Show(Sender: TObject);
var
   i,cpt,jj,mm,aaaa : integer;
   jjdate,jjNextmax,JJEcart : real;
   svar,SPeriode,SEpoque,BufAD,BufDC,nb,SMaxMag,SMinMag,
   jj_s,mm_s,aaaa_s,date_s,JJNM_s, JJEh,JJEm : string;
begin

   With DateTimePicker2 do
   begin
      jj:=DayOf(DateTimePicker2.Date);
      mm:=MonthOf(DateTimePicker2.Date);
      aaaa:=YearOf(DateTimePicker2.Date);
      Str(aaaa:4,aaaa_s);
      Str(mm,mm_s); if mm<10 then mm_s:='0'+mm_s;
      Str(jj,jj_s); if jj<10 then jj_s:='0'+jj_s;
      date_s:=aaaa_s+' '+mm_s+' '+jj_s;
   end;
   jjdate:=SpinEdit1.Value/24+SpinEdit2.Value/60/24+JourJulien(jj,mm,aaaa);
//    Memo1.Lines.Clear;
//    Memo1.Lines.BeginUpdate;

    ListView3.Items.Clear;
    ListView3.Items.BeginUpdate;


    cpt:=0;
    for i:=1 to GCVS_Size do
    begin
       if (GCVS[i]^.visible) and (copy(GCVS[i]^.Type_variable,1,2)='RR') then
       begin

          if GCVS[i]^.Periode>0 then Str(GCVS[i]^.Periode:12:7,SPeriode) else SPeriode:='            ';
          Svar:=GCVS[i]^.Designation+'                  ';
          SVar:=Copy(SVar,1,5)+'  '+Table_Constellation[GCVS[i]^.Constellation].nom+
                '     '+GCVS[i]^.Type_variable+'                 ';
          if GCVS[i]^.Maximum>0 then Str(GCVS[i].Maximum:5:2,SMAxMag) else SMaxMag:=' --- ';
          if GCVS[i]^.Minimum>0 then Str(GCVS[i].Minimum:5:2,SMinMag) else SMinMag:=' --- ';
          SVar:=Copy(SVar,1,22)+'    '+SMaxMag+'   '+SMinMag+' '+SPeriode;
          if GCVS[i]^.Epoque>0 then Str(GCVS[i]^.Epoque:10:4,SEpoque) else
          begin
             if GCVS[i]^.YearNova>0 then
             begin
                Str(GCVS[i]^.YearNova:4:0,SEpoque);
                SEpoque:='('+SEPoque+')     ';
             end
             else SEpoque:='          ';
          end;
          SVar:=SVar+'  '+SEpoque+'  ';
          Str(GCVS[i]^.ADH:2:0,nb);
          bufAD:=nb+' ';
          Str(GCVS[i]^.ADM:2:0,nb);
          bufAD:=bufAD+nb+' ';
          Str(GCVS[i]^.ADS:4:1,nb);
          bufAD:=bufAD+nb+' ';

          Str(GCVS[i]^.DCD-0.00001:3:0,nb);
          bufDC:=nb+' ';
          Str(Abs(GCVS[i]^.DCM):2:0,nb);
          bufDC:=bufDC+nb+' ';
          Str(Abs(GCVS[i]^.DCS):2:0,nb);
          bufDC:=bufDC+nb;
          SVar:=SVar+bufAD+' '+bufDC+'   ';
          // Calcul du prochain maximum :
          if (GCVS[i]^.Periode<>0) and (GCVS[i]^.Epoque<>0) then
          begin
             JJNextMax:=(Trunc((JJdate-GCVS[i]^.Epoque-2400000.0)/GCVS[i]^.Periode)+1)*GCVS[i]^.Periode+GCVS[i]^.Epoque+2400000.0;
             Str(JJNextMax:12:5,JJNM_s);
             SVar:=SVar+JJNM_s;
             JJEcart:=(JJNextMax-JJdate)*24;
             Str(trunc(JJEcart):2,JJEh);
             Str(Trunc((JJEcart-Trunc(JJEcart))*60):2,JJEm);
             if Langage='FR' then
                SVar:=SVar+'  (dans '+JJEh+'h '+JJEm+'m)'
             else
                SVar:=SVar+'  (within '+JJEh+'h '+JJEm+'m)'
          end
          else JJNextMax:=JJdate; // on triche pour forcer l'affichage

          if ((JJNextMax-JJDate)*24)<=SpinEditMaxiavant.Value then
          begin
             ListView3.Items.Add.Caption:=SVar;
             Inc(cpt);
          end;
       end;
    end;
    Str(cpt:6,Svar);
    SVar:=SVar+mesg[21];


    ListView3.Items.Add.Caption:=svar;
    ListView3.Items.EndUpdate;

//
//

end;

procedure TForm1.Button3Click(Sender: TObject);
var
   d : TDateTime;
begin
   DateTimePicker2.Date:=Today;
   d:=Time;
   SpinEdit1.Value:=Trunc(24*(D-int(D)));
   SpinEdit2.Value:=Trunc(60*24*(D-Int(d)-SpinEdit1.Value/24));
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
   TabSheet6Show(Sender);
end;

procedure TForm1.Button5Click(Sender: TObject);
var
   tarot_f : TextFile;
   star,ligne,C,V,Variable : string;
   i : integer;
   trouve : boolean;
begin
   If opendialog1.Execute then
      if FileExists{UTF8}(opendialog1.FileName) { *Converted from FileExists*  } then
      begin
         AssignFile(tarot_f,opendialog1.FileName);
         reset(tarot_f);
         repeat
            readln(Tarot_f,ligne);
            Ligne:=trim(ligne);
            if ligne<>'' then
            if (ligne[1]<>' ') and (ligne[1]<>'-') then
            begin

               Star:=Trim(Copy(ligne,1,10));
               V:=Copy(Star,1,Pos(' ',Star));
               C:=Copy(Star,Pos(' ',Star),length(star));
               Variable:=Trim(C)+Trim(V)+' ';

               i:=RechercheIndex(indexGCVS,GCVS_Size,Variable);
               if i>0 then
                  trouve:=(Copy(Trim(GCVS[i]^.Type_variable),1,2)='RR') else
               trouve:=false;

               if trouve then GCVS[i]^.visible:=true;
            end;
         until eof(tarot_f);
         closefile(tarot_f);
         TabSheet6Show(Sender);
      end;
end;

procedure TForm1.ButtonRecupGEOSClick(Sender: TObject);
var
   buffer,Variable,Constel,URL,FileName_html,To_S,Pe_S : string;
   i,i_gcvs,code : integer;
   message : PAnsiChar;
   f_GEOS : Textfile;
   trouve,gcvs_trouve : boolean;
begin
// http://rr-lyr.ast.obs-mip.fr/Gwenchlan-project/gwenchlan-V1.0_2.php?SS Tau
   FileName_html :='ReponseGEOS.html';
   ButtonRecupGEOS.Enabled:=false;

   for i:=0 to ListView3.Items.Count-2 do
   begin
      Variable:=Trim(Copy(ListView3.Items[i].Caption,1,5));
      Constel:= Trim(Copy(ListView3.Items[i].Caption,8,3));
      URL:='http://rr-lyr.irap.omp.eu/dbrr/rrdb-V2.0_08.3.php?'+Variable+'%20'+Constel+'&';

      if DownloadFileHttp(URL,FileName_html) then
      begin
         AssignFile(f_GEOS,FileName_html);
         reset(f_GEOS);
         trouve:=false;
         repeat
            readln(f_GEOS,buffer);
            If Pos('Current elements:<B>',buffer)>0 then // c'est la bonne ligne
            begin
               Delete(buffer,1,Pos('<B>',buffer)+3);
               buffer:=Copy(buffer,1,Pos('E',buffer));
      //   message:=PAnsiChar(buffer);
      //   Application.MessageBox(message,'');
               To_S:=Trim(Copy(buffer,1,Pos('+',buffer)-1));
               Delete(Buffer,1,Pos('+',buffer)+1);
               buffer:=Trim(Buffer);
               Pe_S:=Trim(Copy(buffer,1,Pos('E',buffer)-1));
               trouve:=true
            end;
         until eof(f_GEOS) or trouve;
         CloseFile(f_GEOS);
         if trouve then
         begin
// Mise à jour des donnes dans la table GCVS en mémoire :
            i_gcvs:=RechercheIndex(indexGCVS,GCVS_size,Constel+Variable+' ');
            GCVS_trouve:=(i_gcvs<>0);
(*
            repeat
               if (Variable+' '+Constel)=(GCVS[i_gcvs]^.Designation+' '+Table_Constellation[GCVS[i_gcvs]^.Constellation].nom) then
                  GCVS_trouve:=true
               else
                  inc(i_gcvs);
            until GCVS_trouve or (i_gcvs>GCVS_size);
*)
            if GCVS_trouve then
               With GCVS[i_gcvs]^ do
               begin
                  Val(To_S,Epoque,code);
                  Epoque:=Epoque-2400000.0;
                  Val(Pe_S,Periode,code);
                  Updated:=true;
//                  message:=PAnsiChar(Variable+' '+Constel+' trouvée ('+To_S+':'+Pe_S+'). Mis à jour table GCVS');
               end
//            else
//               message:=PAnsiChar(Variable+' '+Constel+mesg[22]+' ('+To_S+':'+Pe_S+') hors table GCVS');

         end
//         else

//            message:=PAnsiChar(Variable+' '+Constel+mesg[22]);
//         Application.MessageBox(message,'',MB_OK);

      end;
   end;
//

   TabSheet6Show(Sender);

   ButtonRecupGEOS.Enabled:=True;

end;

procedure TForm1.ButtonRecupNovaeClick(Sender: TObject);
var
   FileName,URL,buffer,gal_nova,aaaa_s,mm_s,jj_s,date_s : string;
   f_novae : Textfile;
   magnitudeNovaeLimite,CritereAlphaMax,CritereAlphaMin,
   CritereDeltaMax,CritereDeltaMin,sn_alpha,sn_delta,SeparationLimite,VOffset,OEW,ONS : real;
   i,c_novae,jj,mm,aaaa,code : integer;
   file_ok,nova_ok : boolean;
   reponse : longint;
   ListItem : TListItem;
   TLBS : ShortString;
begin

   if CheckBoxRechercheNovaDate.Checked then
   begin
      jj:=DayOf(DateTimePicker3.Date);
      mm:=MonthOf(DateTimePicker3.Date);
      aaaa:=YearOf(DateTimePicker3.Date);
      Str(aaaa:4,aaaa_s);
      Str(mm,mm_s); if mm<10 then mm_s:='0'+mm_s;
      Str(jj,jj_s); if jj<10 then jj_s:='0'+jj_s;
      date_s:=aaaa_s+'/'+mm_s+'/'+jj_s;
   end;
   URL:='http://www.rochesterastronomy.org/novae.html';
//   FileName:='CBAT_M31.html';
   FileName:='novae.html';
   TLBS:=Chr(10);
   AssignFile(f_novae,FileName);
   SetTextLineEnding(f_novae,tlbs);
   {$I-}Reset(f_novae); {$I+}
   file_ok:=(IOResult=0);
   if file_ok then closefile(f_novae);

   ButtonRecupNovae.Enabled:=false;

   if file_ok then
   begin
      reponse:=Application.MessageBox(mesg[11],'',MB_YESNOCANCEL);
      case reponse of
      IDNo : file_ok:=DownloadFileHttp(URL,FileName);
      IDYes : file_ok:=true;
      IDCancel : file_ok:=false;
      end;
   end
   else file_ok:=DownloadFileHttp(URL,FileName);
   if file_ok then
   begin
     Val(Trim(LabeledEditMagNovaeLimite.Text),magnitudeNovaeLimite,code);
//

     AssignFile(f_novae,FileName);
     SetTextLineEnding(f_novae,TLBS);
     {$I-}Reset(f_novae); {$I+}
     If IOResult=0 then
     begin
         for c_novae:=1 to Novae_Size do Dispose(novae[c_novae]);
         c_novae:=0;
         repeat
            Readln(f_novae,buffer);
         until Copy(buffer,1,10)='<a name="N';
         ListView4.Items.Clear;
         ListView4.Items.BeginUpdate;
         Memo3.Lines.Add('Détection début des données');
//
         repeat
            buffer:=Trim(buffer);
            if Pos('">Nova ',buffer)>0 then
            begin
               inc(c_novae);
               New(Novae[c_novae]);
               i:=Pos('">Nova ',buffer);
               buffer:=Copy(buffer,i+7,Length(buffer));

               Novae[c_novae]^.galaxie:=Copy(Buffer,1,Pos(' ',buffer)-1);
               Memo3.Lines.Add(Novae[c_novae]^.galaxie);

               // on n'a pas fait le contrôle sur la galaxie


               Novae[c_novae]^.nom:=Copy(buffer,Pos(' ',buffer)+1,8);
               Memo3.Lines.Add(Novae[c_novae]^.nom);
               // on continue la lecture du fichier pour trouver la date de la découverte :

               repeat
                  readln(f_novae,buffer);
               until Pos('discovered',buffer)>0;

               Novae[c_novae]^.date:=Trim(Copy(buffer,Pos('discovered',buffer)+11,10));
               Memo3.Lines.Add(Novae[c_novae]^.date);
               if CheckBoxRechercheNovaDate.Checked then
                  if Novae[c_novae]^.date>date_s then
                     nova_ok:=true
                  else
                     nova_ok:=false
               else
                  nova_ok:=true;

               // on continue la lecture du fichier pour trouver la position :

               repeat
                  readln(f_novae,buffer);
               until Pos('>R.A. =',buffer)>0;
               buffer:=copy(buffer,Pos('>R.A. =',buffer),length(buffer));
               Novae[c_novae]^.Alpha:=Trim(Copy(buffer,9,12));
               Novae[c_novae]^.Delta:=Copy(buffer,31,3)+'°'+Copy(buffer,39,8);
               Memo3.Lines.Add(Novae[c_novae]^.alpha);
               Memo3.Lines.Add(Novae[c_novae]^.delta);

               // on continue la lecture du fichier pour trouver la magnitude :

               repeat
                  readln(f_novae,buffer);
               until Pos('/>Mag',buffer)>0;
               Novae[c_novae]^.mag:=Trim(Copy(buffer,Pos('Mag',buffer)+4,4));
               Memo3.Lines.Add(Novae[c_novae]^.mag);

               If CheckBoxMagLimiteNovae.Checked and (LabeledEditMagNovaeLimite.Text<Novae[c_novae]^.mag) then
                  nova_ok:=false;

(* A réécrire pour disposer de la position précise :
                 Novae[c_novae]^.mag:=Trim(Copy(s_sn,57,4));
                 Novae[c_novae]^.mag:=Novae[c_novae]^.mag+Copy('     ',1,4-length(Novae[c_novae]^.mag));

                 if nova_ok then
                 begin
                    s_sn:=Trim(Copy(s_sn,Pos('</a>',s_sn)+4,Length(s_sn)-4));
                    Novae[c_novae]^.alpha:=copy(s_sn,1,11);
                    Novae[c_novae]^.delta:=copy(s_sn,13,11);

*)

//              nova_ok:=true;

              if nova_ok then
              begin
                 Memo3.Lines.Add('Nova OK');

                //        Novae[c_novae]^.sn_type:=copy(s_sn,1,5);
                //        Novae[c_novae]^.decouvreur:=Trim(copy(s_sn,15,99));
                  With Novae[c_novae]^ do
                     gal_nova:=nom+Copy('  ',1,6-Length(nom))+'  '
                           +galaxie+Copy('            ',1,12-Length(galaxie))
                           +alpha+'  '+delta+'  '+offsets+' '+mag+'    '+sn_type+'    '+decouvreur;
                  if gal_nova<>'' then
                  begin
                     ListItem:=ListView4.Items.Add;
                     ListItem.Caption:=Novae[c_novae]^.date;
                     ListItem.SubItems.Add(gal_nova) ;
                  end;
              end;



              if not nova_ok then
              begin
                 Memo3.Lines.Add('Nova pas OK');

                 Dispose(Novae[c_novae]);
                 Dec(c_novae);
              end;
            end;
            Readln(f_novae,buffer);
         until eof(f_novae);
         ListView4.Items.EndUpdate;
         CloseFile(f_novae);
         Novae_Size:=c_novae;
     end;
   end;
   ButtonRecupNovae.Enabled:=true;
(*
  with ListView do
  begin
    Parent := Self;
    Align := alClient;

    ViewStyle := vsReport;

    NewColumn := Columns.Add;
    NewColumn.Caption := 'Dernier';
    NewColumn := Columns.Add;
    NewColumn.Caption := 'Premier';

    for I := Low(Names) to High(Names) do
    begin
      ListItem := Items.Add;
      ListItem.Caption := Names[I][0];
      ListItem.SubItems.Add(Names[I][1]);
    end;
  end;

*)
end;

procedure TForm1.ListView4Compare(Sender: TObject; Item1, Item2: TListItem;
  Data: Integer; var Compare: Integer);
begin
   if Item1.Caption>Item2.Caption then Compare:=-1;
   if Item1.Caption<Item2.Caption then Compare:=1 else Compare:=0;
end;

procedure TForm1.ButtonImportAFOEVClick(Sender: TObject);
begin
    Form7.ShowModal;
end;

procedure TForm1.ButtonRAZClick(Sender: TObject);
var
   i : longint;
begin
   for i:=1 to GCVS_size do
      GCVS[i]^.visible:=false;
   Form1.TabSheet2Show(sender);
end;

procedure TForm1.ButtonNovaePrismClick(Sender: TObject);
var
   i : integer;
   reponse : longint;
   f_exp : TextFile;
   AD,DC : string;
begin

   if SaveDialog1.Execute then
   begin
      reponse:=IDYES;
      AssignFile(f_exp,SaveDialog1.FileName);
      {$I-}Reset(f_exp); {$I+}
      If IOResult=0 then
      begin
         reponse:=Application.MessageBox(mesg[9],'',MB_YESNOCANCEL);
         closefile(f_exp);
      end;
      AssignFile(f_exp,SaveDialog1.FileName);
      case reponse of
      IDYes : Rewrite(f_exp);
      IDNo  : Append(f_exp);
      end;
      if reponse<>IDCANCEL then
      begin
         For i:=1 to Novae_Size do
            With Novae[i]^ do
               begin
{
00h42m44.75s
+41°15'11.9"
}
                  AD:=Copy(Alpha,1,2)+'h'+Copy(Alpha,4,2)+'m'+Copy(Alpha,7,2)+'.000s';
                  DC:=Copy(Delta,1,3)+Char(248)+Copy(Delta,6,2)+''''+Copy(Delta,9,2)+'.000'+'''''';
                  Writeln(f_exp,'"',nom,'_',galaxie,
                                '"  ',AD,'  ',DC,'  ',mag,'  FALSE  ','"Nova Extragalactique"');

               end;
         Closefile(f_exp);
      end;
   end;



end;

procedure TForm1.RadioButton1Click(Sender: TObject);
begin
    RadioGroup2.Enabled:=False
end;

procedure TForm1.RadioButton2Click(Sender: TObject);
begin
   RadioGroup2.Enabled:=True
end;

procedure TForm1.CheckBoxInfClick(Sender: TObject);
begin
    If CheckBoxInf.Checked then
    begin
       CheckBoxSup.Checked:=False;
       CheckBoxInc.Checked:=False;
    end;
end;

procedure TForm1.CheckBoxSupClick(Sender: TObject);
begin
    If CheckBoxSup.Checked then
    begin
       CheckBoxInf.Checked:=False;
       CheckBoxInc.Checked:=False;
    end;

end;

procedure TForm1.CheckBoxIncClick(Sender: TObject);
begin
    If CheckBoxInc.Checked then
    begin
       CheckBoxSup.Checked:=False;
       CheckBoxInf.Checked:=False;
    end;

end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
   If RadioGroup1.ItemIndex=0 then
      RadioGroup2.Visible:=False
   else RadioGroup2.Visible:=true;
end;

procedure TForm1.BitBtnEffacerMesureAFOEVClick(Sender: TObject);
begin
   LabeledEditPublicAFOEV.Text:='';
end;
procedure TForm1.BitBtnEffacerMesureVSNetClick(Sender: TObject);
begin
   LabeledEditPublicVSNet.Text:='';
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
const
   CodeFiltre : array[0..7] of char = ('Q','L','M','N','O','P','U','W');
var
   value,fracj : real;
   code,hi,mi,si : integer;
   Code_P,Date_S,Date_A,Date_M,Date_J,Mag,Filtre,fracj_s : String;

begin
   If LabeledEditVariablePublic.Text='' then
   begin
      if langage='FR' then
         Application.MessageBox(PChar('Variable indéfini'),'',MB_OK)
      else
         Application.MessageBox(PChar('Undefined variable'),'',MB_OK)
   end
   else
      If LabeledEditObservateur.Text='' then
      begin
         if langage='FR' then
            Application.MessageBox(PChar('Code Observateur indéfini'),'',MB_OK)
         else
            Application.MessageBox(PChar('Undefined Observer code'),'',MB_OK)
      end
      else
      begin
         Val(Trim(MaskEditMagnitude.Text),Value,code);
         If code<>0 then
         begin
            if langage='FR' then
               Application.MessageBox(PChar('Magnitude indéfinie'),'',MB_OK)
            else
               Application.MessageBox(PChar('Undefined Magnitude'),'',MB_OK)
         end
         else
         begin
            If RadioGroup3.ItemIndex=0 then
            begin
               Str(SpinEdit3.Value:4,Date_A);
               Str(SpinEdit4.Value,Date_M); if SpinEdit4.Value<10 then Date_M:='0'+Date_M;
               Str(SpinEdit5.Value,Date_J); if SpinEdit5.Value<10 then Date_J:='0'+Date_J;
               Date_S:=Date_A+Date_M+Date_J;
               Val(Copy(MaskEditHeure.Text,1,2),hi,code);
               Val(Copy(MaskEditHeure.Text,4,2),mi,code);
               Val(Copy(MaskEditHeure.Text,7,2),si,code);
               fracj:=(hi+(mi+si/60)/60)/24;
               Str(fracj:7:5,fracj_s);
               fracj_s:=Copy(fracj_s,2,4);  // on enlève le zero de devant
               Date_S:=Date_S+Fracj_s
            end
            else
               Date_S:=MaskEdit2.Text;
            Code_P:='';
            If CheckBoxInf.Checked then Code_P:='<';
            If CheckBoxSup.Checked then Code_P:='>';
            If CheckBoxInc.Checked then Code_P:=':';

            Filtre:='';                         // Observation visuelle par défaut
            If RadioGroup1.ItemIndex>0 then     // Observation CCD
               Filtre:=CodeFiltre[RadioGroup2.ItemIndex];

            LabeledEditPublicAFOEV.Text:=LabeledEditVariablePublic.Text+' '+Date_S+' '+Code_P+
                                         Trim(MaskEditMagnitude.Text)+Filtre+' '+LabeledEditObservateur.Text;
         end;
      end;
//
end;

procedure TForm1.Publiermesures1Click(Sender: TObject);
var
   i,j : longint;
   s : String;
begin
   i:=ListView1.Selected.Index;
   s:=Trim(Copy(ListView1.Items[i].Caption,8,3))+Trim(Copy(ListView1.Items[i].Caption,1,5))+' ';
   j:=RechercheIndex(IndexGCVS,GCVS_Size,s);
   LabeledEditVariablePublic.Text:=GCVS[j]^.Designation+' '+Table_Constellation[GCVS[j]^.Constellation].nom;
   PageControl1.TabIndex:=6;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
const
   CodeFiltre : array[0..7] of string = ('CR','U','B','V','R','I','U','W');
var
   value,fracj : real;
   code,hi,mi,si : integer;
   s,Code_P,Date_S,Date_A,Date_M,Date_J,Mag,Filtre,fracj_s : String;

begin
   If LabeledEditVariablePublic.Text='' then
   begin
      if langage='FR' then
         Application.MessageBox(PChar('Variable indéfini'),'',MB_OK)
      else
         Application.MessageBox(PChar('Undefined Variable'),'',MB_OK)
   end
   else
      If EditObsVSNet.Text='' then
      begin
         if langage='FR' then
            Application.MessageBox(PChar('Code Observateur indéfini'),'',MB_OK)
         else
            Application.MessageBox(PChar('Undefined Observer code'),'',MB_OK)
      end
      else
      begin
         Val(Trim(MaskEditMagnitude.Text),Value,code);
         If code<>0 then
         begin
            if langage='FR' then
               Application.MessageBox(PChar('Magnitude indéfinie'),'',MB_OK)
            else
               Application.MessageBox(PChar('Undefined Magnitude'),'',MB_OK)
         end
         else
         begin
            If RadioGroup3.ItemIndex=0 then
            begin
               Str(SpinEdit3.Value:4,Date_A);
               Str(SpinEdit4.Value,Date_M); if SpinEdit4.Value<10 then Date_M:='0'+Date_M;
               Str(SpinEdit5.Value,Date_J); if SpinEdit5.Value<10 then Date_J:='0'+Date_J;
               Date_S:=Date_A+Date_M+Date_J;
               Val(Copy(MaskEditHeure.Text,1,2),hi,code);
               Val(Copy(MaskEditHeure.Text,4,2),mi,code);
               Val(Copy(MaskEditHeure.Text,7,2),si,code);
               fracj:=(hi+(mi+si/60)/60)/24;
               Str(fracj:7:5,fracj_s);
               fracj_s:=Copy(fracj_s,2,4);  // on enlève le zero de devant
               Date_S:=Date_S+Fracj_s
            end
            else
               Date_S:=MaskEdit2.Text;
            Code_P:='';
            If CheckBoxInf.Checked then Code_P:='';
            If CheckBoxSup.Checked then Code_P:='';
            If CheckBoxInc.Checked then Code_P:=':';

            Filtre:='';                         // Observation visuelle par défaut
            If RadioGroup1.ItemIndex>0 then     // Observation CCD
               Filtre:=CodeFiltre[RadioGroup2.ItemIndex];
            s:=Copy(MaskEditMagnitude.Text,1,4);
            Delete(s,3,1);
            LabeledEditPublicVSNet.Text:=LabeledEditVariablePublic.Text+' '+Date_S+' '+
                                         Trim(s)+Code_P+Filtre+' '+EditObsVSNet.Text;
         end;
      end;
//

end;

procedure TForm1.PubliermesureSNClick(Sender: TObject);
var
   i : longint;
begin
   i:=ListView2.Selected.Index;
   LabeledEditVariablePublic.Text:='sn'+Trim(Copy(ListView2.Items[i].Caption,1,6));
//   j:=RechercheIndex(IndexGCVS,GCVS_Size,s);
// GCVS[j]^.Designation+' '+Table_Constellation[GCVS[j]^.Constellation].nom;
   PageControl1.TabIndex:=6;
end;

procedure TForm1.TabSheet7Show(Sender: TObject);
begin
   if RadioGroup3.ItemIndex>0 then SpeedButton2.Enabled:=False else SpeedButton2.Enabled:=true;
   LabeledEditObservateur.Text:=Rapport_Obs_AFOEV;
   EditObsVSNet.Text:=Rapport_Obs_VSNet;
end;

procedure TForm1.RadioGroup3Click(Sender: TObject);
begin
   if RadioGroup3.ItemIndex>0 then SpeedButton2.Enabled:=False else SpeedButton2.Enabled:=true;
end;

procedure TForm1.BitBtnAjoutMesureAFOEVClick(Sender: TObject);
var
   f_AFOEV : TextFile;
begin
   SaveDialog1.FileName:=Fic_RapportAFOEV;
   AssignFile(f_AFOEV,SaveDialog1.FileName);
   if not FileExists{UTF8}(SaveDialog1.FileName) { *Converted from FileExists*  } then
      Rewrite(f_AFOEV)
   else
      Append(f_AFOEV);
   Writeln(f_AFOEV,LabeledEditPublicAFOEV.Text);
   CloseFile(F_AFOEV);
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
var
   JJDate : real;
   hh,mm,ss : real;
   code : integer;
   JJ_s : string;
begin
   JJDate:=JourJulien(SpinEdit5.Value,SpinEdit4.Value,SpinEdit3.Value);
   Val(Copy(MaskEditHeure.Text,1,2),hh,code);
   Val(Copy(MaskEditHeure.Text,4,2),mm,code);
   Val(Copy(MaskEditHeure.Text,7,2),ss,code);
   hh:=hh+(mm+ss/60)/60;
   JJDate:=JJDate+hh/24-2400000.0;
   Str(JJDate:9:3,JJ_s);
   MaskEdit2.Text:=JJ_s;
end;

procedure TForm1.PublierMesureNovaClick(Sender: TObject);
var
   i : longint;
   Nova_ligne : string;
begin

   Nova_ligne:=ListView4.Selected.SubItems[0];
   LabeledEditVariablePublic.Text:='Nova '+Trim(Copy(Nova_Ligne,11,4))+' '+Trim(Copy(Nova_Ligne,1,8));

   PageControl1.TabIndex:=6;

end;

procedure TForm1.LabeledEditObservateurChange(Sender: TObject);
begin
   Rapport_Obs_AFOEV:=LabeledEditObservateur.Text;
end;

procedure TForm1.EditObsVSNetChange(Sender: TObject);
begin
   Rapport_Obs_VSNET:=EditObsVSNet.Text;
end;

procedure TForm1.SpinEditMaxiAvantChange(Sender: TObject);
begin
   TabSheet5.Show;
   TabSheet6.Show;
end;

procedure TForm1.CheckBoxNordClick(Sender: TObject);
begin
   VariableCarteNordEHaut:=CheckBoxNord.Checked;
end;

procedure TForm1.ButtonVarSuivanteClick(Sender: TObject);
var
   i : integer;
   obj_pub,obj_pub_gal : string;
begin
   obj_pub:=Trim(LabeledEditVariablePublic.Text);
   if Copy(Trim(obj_pub),1,3)='sn2' then
   begin
      if SN_Size>1 then
      begin
         obj_pub:=Trim(Copy(obj_pub,3,Length(obj_pub)-2));
         i:=0;
         repeat
            inc(i);
         until (i=SN_Size) or (SN[i].nom=obj_pub);
         if (i<SN_size) and (SN[i]^.nom=obj_pub)  then
         begin
            obj_pub:='sn'+SN[i+1]^.nom;
            LabeledEditVariablePublic.Text:=obj_pub;
         end
      end

   end
   else
   if Copy(Trim(obj_pub),1,4)='Nova' then
   begin
      if Novae_Size>1 then
      begin
         obj_pub:=Trim(Copy(obj_pub,5,Length(obj_pub)-4));
         obj_pub_gal:=Trim(Copy(obj_pub,1,Pos(' ',obj_pub)-1));
         obj_pub:=Trim(Copy(obj_pub,Pos(' ',obj_pub)+1,Length(obj_pub)));
         i:=0;
         repeat
            inc(i);
         until (i=Novae_Size) or ((Novae[i].nom=obj_pub) and (Novae[i]^.galaxie=obj_pub_gal));
         if (i<Novae_Size) and (Novae[i]^.nom=obj_pub) and (Novae[i]^.galaxie=obj_pub_gal) then
         begin
            obj_pub:='Nova '+Novae[i+1]^.galaxie+' '+Novae[i+1]^.nom;
            LabeledEditVariablePublic.Text:=obj_pub;
         end
      end
   end
   else // on recherche dans le GCVS
   begin
      Obj_pub:=Copy(obj_pub,Pos(' ',obj_pub)+1,Length(obj_pub))+Copy(Obj_pub,1,Pos(' ',obj_pub)-1)+' ';
      i:=RechercheIndex(indexGCVS,GCVS_Size,obj_pub);
      if (i>0) and (i<GCVS_Size) then
      begin
         repeat
            inc(i);
         until (i=GCVS_size) or (GCVS[i]^.visible);
         if (i<=GCVS_size) and (GCVS[i]^.visible) then
         begin
            obj_pub:=GCVS[i].Designation+' '+Table_Constellation[GCVS[i]^.Constellation].nom;
            LabeledEditVariablePublic.Text:=obj_pub;
         end
      end;
   end;
end;

procedure TForm1.LabeledEdit7Change(Sender: TObject);
var
   i : integer;
   variable,b,v,c : string;
begin
   i:=0;
   b:=Upcase(Trim(LabeledEdit7.Text));
   if length(b)>4 then
   begin
      V:=Copy(b,1,length(b)-3);
      C:=Copy(LabeledEdit7.Text,length(b)-2,3);
      Variable:=Trim(C)+Trim(V)+' ';

      i:=RechercheIndex(indexGCVS,GCVS_size,variable);
   end;
   if i>0 then LabeledEdit7.Font.Color:=clBlack else LabeledEdit7.Font.Color:=clRed
end;

procedure TForm1.Voirdtails2Click(Sender: TObject);
var
   i,j : longint;
   s : String;
begin
   i:=ListView1.Selected.Index;
   s:=Trim(Copy(ListView1.Items[i].Caption,8,3))+Trim(Copy(ListView1.Items[i].Caption,1,5))+' ';
   j:=RechercheIndex(IndexGCVS,GCVS_Size,s);
//   LabeledEditVariablePublic.Text:=GCVS[j]^.Designation+' '+Table_Constellation[GCVS[j]^.Constellation].nom;
//   PageControl1.TabIndex:=6;


   if j>0 then
   begin
      GCVS_courant:=j;
      Affiche_variable(Sender,GCVS_courant);
      ButtonPublierMesures.Enabled:=true;
      ButtonRechAAVSO.Enabled:=true;
      ButtonEtalon.Enabled:=true;
      ButtonMesureAFOEV.Enabled:=true;

      PageControl1.TabIndex:=2;
   end
end;

procedure TForm1.ButtonPublierMesuresClick(Sender: TObject);
begin
   with GCVS[GCVS_courant]^ do
   begin
      LabeledEditVariablePublic.Text:=Designation+' '+Table_Constellation[Constellation].nom;
      PageControl1.TabIndex:=6;
   end;
end;

procedure TForm1.TabSheet3Show(Sender: TObject);
begin
   If TabSheet3.Enabled then LabeledEdit7.SetFocus;
end;

procedure TForm1.ButtonImportVariableClick(Sender: TObject);
var
   f_import : TextFile;
   j        : longint;
   buffer,etoile,constl,g,d : string;
begin
   if opendialog1.Execute then
   begin
      AssignFile(f_import,Opendialog1.FileName);
      {$I-}Reset(f_import); {$I+}
      If IOResult=0 then
      begin
         repeat
            { La routine lit des fichiers provenant de PRISM, c'est dire au format :
               "XX CST" bla bla
               "VXXXX CST" bla bla
               "V_XXXCST" bla bla
               "VXXXXCST" bla bla
               "XX_CST" bla bla
               "X_CST" bla bla }

            readln(f_import,buffer);
            if length(buffer)>0 then
            begin


               if (buffer[1]='"') then
               begin
                  buffer:=Trim(buffer);
                  buffer:= Copy(buffer,2,length(buffer)-1);   {on enlève le premier guillemet }
                  if pos('"',buffer)<>0 then
                  begin
                     buffer:=Copy(buffer,1,pos('"',buffer)-1);         { on prend ce qu'il y a jusqu'au second guillemet}
                     buffer:=Upcase(buffer);                           { On enlève le second guillemet }
                     j:=0;
                     if pos(' ',buffer)>0 then                         { Cas "XX CST" ou "VXXXX CST" }
                     begin
                        etoile:=Copy(buffer,1,Pos(' ',buffer)-1);
                        constl:=Copy(buffer,Pos(' ',buffer)+1,3);
                        j:=RechercheIndex(IndexGCVS,GCVS_Size,Constl+Etoile+' ');
                        if j>0 then
                           GCVS[j]^.visible:=true
                     end
                     else
                     begin
                        constl:=Copy(buffer,Length(buffer)-2,3);
                        g:=Copy(buffer,1,length(buffer)-3);
                        if (Pos('V_',g)=1) then g[2]:='0';
                        if (Pos('_',g)<>0) then g[Pos('_',g)]:=' ';
                        g:=Trim(g);

                        etoile:=Copy(g,1,5);

                        j:=RechercheIndex(IndexGCVS,GCVS_Size,Constl+Etoile+' ');
                        if j>0 then
                           GCVS[j]^.visible:=true;


                     end
                  end
               end else
               begin
                  { La routine lit des fichiers de liste simple, c'est dire au format :

                  XX CST bla bla
                         bla bla
                  VXXXX CST bla bla

                  La premiere colonne ne doit pas être un caractère blanc

                  V:=Copy(b,1,Length(b)-4);
                  C:=Copy(b,Length(b)-2,3);
                  Variable:=Trim(C)+Trim(V)+' ';
                  i:=RechercheIndex(indexGCVS,GCVS_size,variable);

                  }
                  if pos(' ',buffer)>1 then      { Cas "XX CST" ou "VXXXX CST" }
                  begin
                     j:=0;
                     buffer:=Upcase(buffer);  { On met tout en majuscule pour faire la recherche }
                     etoile:=Copy(buffer,1,Pos(' ',buffer)-1);
                     constl:=Copy(Trim(Copy(buffer,Pos(' ',buffer)+1)),1,3);
                     j:=RechercheIndex(IndexGCVS,GCVS_Size,Constl+Etoile+' ');
                     if j>0 then
                        GCVS[j]^.visible:=true
                  end
               end;
            end;
         until eof(f_import);
         closefile(f_import);
         TabSheet2Show(Sender);
      end;
   end
end;

procedure TForm1.Misejour1Click(Sender: TObject);
var
   URL,buffer,FileVersion : string;
   f_version              : TextFile;
begin
      URL:='http://www.astrosurf.com/noctambule/ginseng/derniere_version.txt';
      Fileversion:='derniere_version.txt';

      if DownloadFileHttp(URL,FileVersion) then
      begin
         AssignFile(f_version,FileVersion);
         reset(f_version);
         readln(f_version,buffer);
         if buffer=mesg[7] then
            Application.MessageBox(PChar(mesg[16]),'',MB_OK)
         else
            Application.MessageBox(PChar(buffer+String(mesg[17])),'',MB_OK);
         Closefile(f_version);
      end;
end;

procedure TForm1.Zoom1Click(Sender: TObject);
var
   g,fichier : string;
begin
   //
   if LabeledEdit8.Text<>'' then
   with GCVS[GCVS_courant]^ do
   begin
      g:=designation+' '+Table_Constellation[Constellation].nom;
      fichier:=rep_AAVSO+'\'+designation+' '+Table_Constellation[Constellation].nom+'.png';
   end
   else fichier:=rep_AAVSO+'\zone.png';   { Cas d'une zone Alpha,Delta }
   Form6.Image1.Picture.LoadFromFile(Fichier);
   Form6.Caption:=g;
   Form6.Show
end;

procedure TForm1.ButtonEtalonClick(Sender: TObject);
   procedure coupe_ph_html_sup(t : string; var g,d : string);
   // cette procedure retourne les deux sous-chaines de t séparées par un >
   // la chaine de gauche contiendra le >
   var
      i,l : integer;
      s : string;
   begin
      s:=Trim(t);
      l:=length(s);
      if l>1 then
      begin
         i:=0;
         repeat
            inc(i)
         until (s[i]='>') or (i=l);
         d:='';
         g:='';
         if i>1 then g:=Copy(s,1,i);
         if i<l then d:=Copy(s,i+1,l-i);
      end;
      g:=Trim(g);
      d:=Trim(d);
   end;
   procedure coupe_ph_html_inf(t : string; var g,d : string);
   // cette procedure retourne les deux sous-chaines de t séparées par un <
   // la chaine de droite contiendra le <
   var
      i,l : integer;
      s : string;
   begin
      s:=Trim(t);
      l:=length(s);
      if l>1 then
      begin
         i:=0;
         repeat
            inc(i)
         until (s[i]='<') or (i=l);
         d:='';
         g:='';
         d:=Copy(s,i+1,l-i);
         if i>1 then g:=Copy(s,1,i-1);
      end;
      g:=Trim(g);
      d:=Trim(d);
   end;


var
   URL,OFichier,NFichier,
   buffer,t,g,d,sads,sdcs,sauid,slabel,north,east,
   bande,magU,magB,magV,magR,magI,magJ,magH,magK,
   svaleur,rahs,rams,rass,
   dcds,dcms,dcss,nomzone    : string;
   f_etalon,o_etalon         : textfile;
   cpt_etalon,nb_etalon,bandi,
   code,rah,ram,dcd,dcm      : integer;
   reponse                   : longint;
   file_OK                   : boolean;
   flags                     : TReplaceFlags;
   vJSONData                 : TJSONData;
   valeur,maglim,ra,dc,ras,dcs : real;
begin
   ButtonEtalon.Enabled:=false;
//   AssignFile(esp,'espion.txt');
//   Rewrite(esp);
{ TODO : Corriger la ligne de demande de récupération en y mettant le champ et
         la magnitude limite. La magnitude limite devra être crée sur l'onglet
         variable
}

   URL:='https://app.aavso.org/vsp/api/chart/?format=json';
   Val(EditTailleChamp.Caption,valeur,code);
   if code=0 then URL:=URL+'&fov='+Trim(EditTailleChamp.Text);
   Val(EditMaglimit.Text,maglim,code);
   if code=0 then URL:=URL+'&maglimit='+Trim(EditMaglimit.Text);
   if CheckboxNord.State=cbChecked then north:='up' else north:='down';
   if CheckboxEst.State=cbChecked then east:='left' else east:='right';

 {  URL:=URL+'&other=gcvs&lines=on&east='+east+'&north='+north; }

   with GCVS[GCVS_courant]^ do
   begin
      if LabeledEdit8.Text<>'' then
      begin
         URL:=URL+'&star='+designation+'+'
                 +Table_Constellation[Constellation].nom;
         NFichier:=rep_AAVSO+'\'+designation+' '
                 +Table_Constellation[Constellation].nom+'.json';
         OFichier:=rep_AAVSO+'\'+designation+' '
                 +Table_Constellation[Constellation].nom+'_etalon_json.txt';
      end else
      begin
{
          URL_requete:='https://app.aavso.org/vsp/api/chart/?ra='+LabeledEdit14.Text+'&dec='+LabeledEdit15.Text+
                      '&fov='+Trim(EditTailleChamp.Text)+'&maglimit='+Trim(EditMaglimit.Text)+'&east='+east+'&north='+north+
                      '&format=json';

                                       }

         URL:=URL+'&ra='+LabeledEdit14.Text+'&dec='+LabeledEdit15.Text;
//         Form4.LabeledEditRA.Text:=LabeledEdit14.Text;
//         Form4.LabeledEditDEC.Text:=LabeledEdit15.Text;
//         Form4.Show;

         NFichier:=rep_AAVSO+'\'+{Form4.LabeledEditNomZone.Text+}'zone.json';
         OFichier:=rep_AAVSO+'\'+{Form4.LabeledEditNomZone.Text+}'zone_etalon_json.txt';
      end;

      File_OK:=FileExists{UTF8}(NFichier); { *Converted from FileExists*  }

      if file_ok then
      begin
         reponse:=Application.MessageBox(mesg[23],'',MB_YESNOCANCEL);
         case reponse of
         IDNo : file_ok:=DownloadFileHttp(URL,NFichier);
         IDYes : file_ok:=true;
         IDCancel : file_ok:=false;
         end;
      end
      else file_ok:=DownloadFileHttp(URL,NFichier);

      if file_OK then    // Analyse de la réponse
      begin
         AssignFile(f_etalon,NFichier);
         reset(f_etalon);
         AssignFile(o_etalon,OFichier);
         Reponse:=IDYes;
         {$I-}Reset(o_etalon); {$I+}
         If IOResult=0 then
         begin
            reponse:=Application.MessageBox(mesg[9],'',MB_YESNOCANCEL);    // Ajout ou écrasement
            closefile(o_etalon);
         end;
         AssignFile(o_etalon,OFichier);
         case reponse of
         IDYes : Rewrite(o_etalon);
         IDNo  : Append(o_etalon);
         end;
         if reponse<>IDCANCEL then
         begin
            readln(f_etalon,buffer);         // Lecture du fichier JSON
            vJSONData := GetJSON(buffer);
            nb_etalon:=vJSONData.FindPath('photometry').Count;

            if nb_etalon<1 then
            begin
               Application.MessageBox(PChar(mesg[18]),'',MB_OK);
               Writeln(o_etalon,'Pas de photométrie.');
            end
            else
            begin
   // Au moins un étalon est défini


               if vJSONData.Findpath('star').IsNull then // Cas de la réponse pour une zone
               begin
                  nomzone:='Zone';
                  sauid:='AUID';
               end
               else
               begin
                  nomzone:=designation+' '+Table_Constellation[Constellation].nom;
                  sauid:=vJSONData.FindPath('auid').AsString;
               end;
               if Pos(':',vJSONData.FindPath('ra').AsString)=0 then
               begin    // Le codage des coordonnées est différent de la réponse pour une variable
                  ra:=vJSONData.FindPath('ra').AsFloat;
                  dc:=vJSONData.FindPath('dec').AsFloat;
                  ra:=ra/15;
                  rah:=trunc(ra);
                  ram:=trunc(60*(ra-rah));
                  ras:=3600*(ra-rah-ram/60);
                  Str(rah:0,rahs); if rah<10 then rahs:='0'+rahs;
                  Str(ram:0,rams); if ram<10 then rams:='0'+rams;
                  Str(ras:5:3,rass); if ras<10 then rass:='0'+trim(rass);

                  sads:=rahs+'h'+rams+'m'+rass+'s';

                  dcd:=trunc(abs(dc));
                  dcm:=trunc(60*(abs(dc)-dcd));
                  dcs:=3600*(abs(dc)-dcd-dcm/60);
                  Str(dcd:2:0,dcds); if dcd<10 then dcds:='0'+dcds; if dc<0 then dcds:='-'+dcds;
                  Str(dcm:2:0,dcms); if dcm<10 then dcms:='0'+dcms;
                  Str(dcs:5:3,dcss); if dcs<10 then dcss:='0'+trim(dcss);
                  sdcs:=dcds+'d'+dcms+'m'+dcss+'s';

               end
               else  // Cas de la réponse pour une étoile
               begin
                  sads:=vJSONData.FindPath('ra').AsString;
                  sdcs:=vJSONData.FindPath('dec').AsString;

                  // Passage des coordonnées au format lisible directement par les scripts de PRISM :
                  sads:=StringReplace(sads,':','h',[rfIgnoreCase]);
                  sads:=StringReplace(sads,':','m',[rfIgnoreCase]);
                  sads:=sads+'0s';
                  sdcs:=StringReplace(sdcs,':','d',[rfIgnoreCase]);
                  sdcs:=StringReplace(sdcs,':','m',[rfIgnoreCase]);
                  sdcs:=sdcs+'00s';
               end;
               Writeln(o_etalon,nomzone,',',sads,',',sdcs,',',sauid);
               Form9.Show;

               with Form9.StringGridEtalon do
               begin
                  RowCount:=2;
                  Cells[0,0]:='Star'; ColWidths[0]:=70;
                  Cells[1,0]:='Alpha (H:M:S]'; ColWidths[1]:=80;
                  Cells[2,0]:='Delta (D:M:S]'; ColWidths[2]:=80;
                  Cells[3,0]:='Label'; ColWidths[3]:=50;
                  Cells[4,0]:='U'; ColWidths[3]:=60;
                  Cells[5,0]:='B'; ColWidths[3]:=60;
                  Cells[6,0]:='V'; ColWidths[3]:=60;
                  Cells[7,0]:='Rc'; ColWidths[3]:=60;
                  Cells[8,0]:='Ic'; ColWidths[3]:=60;
                  Cells[9,0]:='J'; ColWidths[3]:=60;
                  Cells[10,0]:='H'; ColWidths[3]:=60;
                  Cells[11,0]:='K'; ColWidths[3]:=60;
               end;

   // on supprime l'entete avec l'étoile variable pour ne garder que les données des étalons :


               for cpt_etalon:=0 to nb_etalon-1 do
               begin

                  Form9.StringGridEtalon.Update;

                   // décodage des valeurqs des etalons :
                  sads:=vJSONData.FindPath('photometry').Items[cpt_etalon].FindPath('ra').AsString;
                  sdcs:=vJSONData.FindPath('photometry').Items[cpt_etalon].FindPath('dec').AsString;

                  // Passage des coordonnées au format lisible directement par les scripts de PRISM :
                  sads:=StringReplace(sads,':','h',[rfIgnoreCase]);
                  sads:=StringReplace(sads,':','m',[rfIgnoreCase]);
                  sads:=sads+'0s';

                  sdcs:=StringReplace(sdcs,':','d',[rfIgnoreCase]);
                  sdcs:=StringReplace(sdcs,':','m',[rfIgnoreCase]);
                  sdcs:=sdcs+'00s';

                  Write(o_etalon,vJSONData.FindPath('photometry').Items[cpt_etalon].FindPath('auid').AsString,',',
                                 sads,',',sdcs,',',
                                 vJSONData.FindPath('photometry').Items[cpt_etalon].FindPath('label').AsString,',');

                  Form9.StringGridEtalon.Cells[0,Form9.StringGridEtalon.RowCount-1]:=vJSONData.FindPath('photometry').Items[cpt_etalon].FindPath('auid').AsString;
                  Form9.StringGridEtalon.Cells[1,Form9.StringGridEtalon.RowCount-1]:=vJSONData.FindPath('photometry').Items[cpt_etalon].FindPath('ra').AsString;
                  Form9.StringGridEtalon.Cells[2,Form9.StringGridEtalon.RowCount-1]:=vJSONData.FindPath('photometry').Items[cpt_etalon].FindPath('dec').AsString;
                  Form9.StringGridEtalon.Cells[3,Form9.StringGridEtalon.RowCount-1]:=vJSONData.FindPath('photometry').Items[cpt_etalon].FindPath('label').AsString;

                  magU:='-';
                  magB:='-';
                  magV:='-';
                  magR:='-';
                  magI:='-';
                  magJ:='-';
                  magH:='-';
                  magK:='-';

                  for bandi:=0 to vJSONData.FindPath('photometry').Items[cpt_etalon].FindPath('bands').Count-1 do
                  begin
                     valeur:=vJSONData.FindPath('photometry').Items[cpt_etalon].FindPath('bands').Items[bandi].FindPath('mag').AsFloat;
                     Str(valeur:6:3,svaleur);
                     Svaleur:=Trim(svaleur);
                     bande:=vJSONData.FindPath('photometry').Items[cpt_etalon].FindPath('bands').Items[bandi].FindPath('band').AsString;
                     if bande='U' then magU:=svaleur;
                     if bande='B' then magB:=svaleur;
                     if bande='V' then magV:=svaleur;
                     if bande='Rc' then magR:=svaleur;
                     if bande='Ic' then magI:=svaleur;
                     if bande='J' then magJ:=svaleur;
                     if bande='H' then magH:=svaleur;
                     if bande='K' then magK:=svaleur;

                  end;
                  Form9.StringGridEtalon.Cells[4,Form9.StringGridEtalon.RowCount-1]:=magU;
                  Form9.StringGridEtalon.Cells[5,Form9.StringGridEtalon.RowCount-1]:=magB;
                  Form9.StringGridEtalon.Cells[6,Form9.StringGridEtalon.RowCount-1]:=magV;
                  Form9.StringGridEtalon.Cells[7,Form9.StringGridEtalon.RowCount-1]:=magR;
                  Form9.StringGridEtalon.Cells[8,Form9.StringGridEtalon.RowCount-1]:=magI;
                  Form9.StringGridEtalon.Cells[9,Form9.StringGridEtalon.RowCount-1]:=magJ;
                  Form9.StringGridEtalon.Cells[10,Form9.StringGridEtalon.RowCount-1]:=magH;
                  Form9.StringGridEtalon.Cells[11,Form9.StringGridEtalon.RowCount-1]:=magK;

                  Form9.StringGridEtalon.RowCount:=Form9.StringGridEtalon.RowCount+1;
                  Writeln(o_etalon,magU,',',magB,',',magV,',',magR,',',magI,',',magJ,',',magH,',',magK);
               end;
               Form9.StringGridEtalon.RowCount:=Form9.StringGridEtalon.RowCount-1;

               Str(nb_etalon:0,buffer);
               if nb_etalon<2 then
                  buffer:=buffer+mesg[19]
               else
                  buffer:=buffer+mesg[20];
               Application.MessageBox(PChar(buffer),'',MB_OK);
            end;
            Closefile(o_etalon);
         end;
         Closefile(f_etalon);
      end;
   end;
   ButtonEtalon.Enabled:=true;

end;

procedure TForm1.ButtonAjoutVisibleClick(Sender: TObject);
begin
   GCVS[GCVS_courant]^.visible:=true;
   ButtonMesuresAFOEVListe.enabled:=true;
end;

procedure TForm1.ButtonPrecedentListeClick(Sender: TObject);
var
   i : integer;
begin
   i:=GCVS_courant;
   repeat
      dec(i);
   until GCVS[i].visible or (i=1);
   if GCVS[i]^.visible then
   begin
      GCVS_courant:=i;
      Affiche_variable(Sender,i);
   end;
end;

procedure TForm1.ButtonSuivantListeClick(Sender: TObject);
var
   i : integer;
begin
   i:=GCVS_courant;
   repeat
      inc(i);
   until GCVS[i].visible or (i=GCVS_size);
   if GCVS[i]^.visible then
   begin
      GCVS_courant:=i;
      Affiche_variable(Sender,i);
   end;
end;

procedure TForm1.ButtonEtalonsClick(Sender: TObject);
begin
  // penser à activer ce bouton en mode expert
   // faire une boucle sur la liste d'objets courants et appeler pour chaque
   // variable trouvée la procedure d'extraction des étalons.
end;

end.
