unit decoupe;

interface

uses textstrings;

{Module de dcoupe de phrase en mots spar par des blancs}
const
   max_mot = 50;
type
   t_phrase = array[1..max_mot] of string[40];



procedure decouper(buffer : string;sep : char;  var mot : t_phrase);
procedure decouper_csv(csvfilename{buffer} : string;sep,enc : char;  var mot : t_phrase; var nb_mot : integer);
// function trim(ch : string) : string;

implementation
{
function trim(ch : string): string;
var
   s   : string;
   i,l : integer;
begin
   i:=0;
   s:='';
   l:=length(ch);
   if l>0 then
   begin
      repeat
         inc(i);
      until (i=l) or (ch[i]<>' ');
      if (i<=l) then s:=copy(ch,i,l-i+1);

      l:=length(s);
      if l>0 then
         while s[l]=' ' do
         begin
            s:=copy(s,1,l-1);
            l:=length(s);
         end;
   end;
   trim:=s;
end;
}
procedure decouper(buffer : string;sep : char;  var mot : t_phrase);
var
   i,j,l : integer;
begin

   for j:=1 to max_mot do mot[j]:='';

   i:=1;
   j:=0;
   l:=length(buffer);

   if l>0 then
   begin
      if buffer[i]=sep then
      repeat
         inc(i);
      until (buffer[i]<>sep) or (i>l); { On passe les blancs de tete }
      if i<=l then
      begin
         repeat
            if buffer[i]=sep then
            begin
               if buffer[i-1]<>sep then inc(j);
               i:=i+1
            end
            else
            begin
               if j=0 then j:=1;
               mot[j]:=mot[j]+buffer[i];
               inc(i);
            end

         until i>length(buffer);
      end;
   end;
end;

procedure decouper_csv(csvfilename{buffer} : string;sep,enc : char;  var mot : t_phrase; var nb_mot : integer);
{ Dcoupe un chaine de caractres en recherchant les textes ENCADRES par deux caractres ENC (guillemets)
  et spars par SEP } { modifi le 19/9/2020 pour G'ngseng }
var
   i,j,l,deb : integer;
   ChaineDeTextes : TTextStrings;
begin
   for j:=1 to max_mot do mot[j]:='';

   i:=0;
   j:=0;
//   l:=length(buffer);
   ChainedeTextes.Delimiter:=',';
   ChainedeTextes.QuoteChar:='"';

   ChainedeTextes.LoadFromFile(csvfilename);

   nb_mot:=ChainedeTextes.Count;

   if nb_mot>0 then
      for i:=1 to nb_mot do
      begin
         mot[i]:=ChainedeTextes.names[i];
      end;

{
   if l>0 then
   repeat
      inc(i);
      if buffer[i]=sep then // Premier SEP trouv
      begin
         deb:=i;
         repeat
             inc(i);
         until (buffer[i]=sep) or (i=l); // On cherche le second SEP de la fin d'un mot
         if buffer[i]=sep then
         begin                           // on a trouv la fin d'un mot
            inc(j);
            mot[j]:=copy(buffer,deb,i-deb+1);
         end;
      end;
   until i=l;
   nb_mot:=j;
}
end;

begin
end.
